/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "about.h"

Aboutdialog::Aboutdialog( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
        setName( "Aboutdialog" );
    setSizeGripEnabled( TRUE );
    AboutdialogLayout = new QVBoxLayout( this, 11, 6, "AboutdialogLayout");

    tabWidget = new QTabWidget( this, "tabWidget" );

    Widget8 = new QWidget( tabWidget, "Widget8" );
    Widget8Layout = new QVBoxLayout( Widget8, 11, 6, "Widget8Layout");

    textBrowser13 = new QTextBrowser( Widget8, "textBrowser13" );
    textBrowser13->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)5, 0, 0, textBrowser13->sizePolicy().hasHeightForWidth() ) );
    Widget8Layout->addWidget( textBrowser13 );
    tabWidget->insertTab( Widget8, QString("") );

    Widget9 = new QWidget( tabWidget, "Widget9" );
    Widget9Layout = new QVBoxLayout( Widget9, 11, 6, "Widget9Layout");

    textBrowser14 = new QTextBrowser( Widget9, "textBrowser14" );
    Widget9Layout->addWidget( textBrowser14 );
    tabWidget->insertTab( Widget9, QString("") );

    TabPage = new QWidget( tabWidget, "TabPage" );
    TabPageLayout = new QVBoxLayout( TabPage, 11, 6, "TabPageLayout");

    textBrowser15 = new QTextBrowser( TabPage, "textBrowser15" );
    TabPageLayout->addWidget( textBrowser15 );
    tabWidget->insertTab( TabPage, QString("") );
    AboutdialogLayout->addWidget( tabWidget );

    Layout1 = new QHBoxLayout( 0, 0, 6, "Layout1");
    Horizontal_Spacing2 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( Horizontal_Spacing2 );

    buttonCancel = new QPushButton( this, "buttonCancel" );
    buttonCancel->setAutoDefault( TRUE );
    Layout1->addWidget( buttonCancel );
    AboutdialogLayout->addLayout( Layout1 );
    languageChange();
    resize( QSize(528, 363).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
Aboutdialog::~Aboutdialog()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void Aboutdialog::languageChange()
{
    setCaption( tr( "About" ) );
    textBrowser13->setText( tr( "This <b>educative software</b> was written as a thesis <br>2004-2005<br><br>I want students from all over the planet to gain knowledge about fysical and mathematical statements in a way that it is fun to do. The students can study the theory and they can make some exercices. This Software is written to be used in schools and at home.<br><br>Everybody who has some new ideas conserning this project may send me an e-mail. All help is welcome!! (translations from dutch to english, more exercices, new programs, ...)<br>toon.muylkens@pandora.be" ) );
    tabWidget->changeTab( Widget8, tr( "About" ) );
    textBrowser14->setText("<b>Muylkens Toon</b> -->Project leader, Main developer<br><b>Decoster Thomas</b> -->Package testing, Icons, Translations<br><b>Tony</b> ---> removing spell errors");
    tabWidget->changeTab( Widget9, tr( "Author" ) );

QString locale_small;
locale_small=QTextCodec::locale();
locale_small.setLength(2);

    QString gpl;
     QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
    gpl.append(appBaseDir);
 gpl.append("html_pages/gpl_");
gpl.append(locale_small);
gpl.append(".html");

      textBrowser15->setSource( gpl);
    tabWidget->changeTab( TabPage, tr( "Licence" ) );
    buttonCancel->setText( tr( "&Close" ) );
    buttonCancel->setAccel( QKeySequence( tr( "Alt+S" ) ) );
}

