/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 #include "awidgeta.h"
#include <stdio.h>
#include <iostream>


using namespace std;

Widgeta::Widgeta( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
	// "Nimbius Sans"
	this->setFont(QFont( "Bitstream Vera Sans", 12, QFont::Normal));
	setstandards();
	makecanvas();
	makelines();
	makebuttons();
	makegrid();
	addlayouts();
	makelabels();
	maketekstinfo();
	allesingrid();	  
	
	QColor pen(255,230,65);
  	QPen solidline(pen, 25);
	solidline.setStyle (SolidLine);
   	linea->setPen(solidline);
  	linea->show();
	lineb->setPen(solidline);
	lineb->show();
	linec->setPen(solidline);
	linec->show();
	lined->setPen(solidline);
	lined->show();
	
	linee->setPen(solidline);
	linee->show();
	
	updatecanvas();
	
	// zou moeten werken??? =>
	//QObject *gh = (QObject*)alphahoek->slider;
	//connect(gh, SIGNAL(sliderReleased()), this , SLOT(doupdate()) );
}

Widgeta::~Widgeta()
{}

void Widgeta::setstandards()
{
number = 0;
}

void Widgeta::tostart()
{
number=6;
updatecanvas();
}

void Widgeta::next()
{	
	//for (int i=lastxa;i<xa->value();i++){usleep(1000);
	number++;
	cout << "next!" <<"number = "<<number<< endl;
	updatecanvas();
}

void Widgeta::drawlines(QCanvasLine *line, int xa, int ya, int xb, int yb)
{
int stappen = (yb-ya)/2;   //stappen moeten afhankelijk zijn aan de lengte van de lijnen, anders is er snelheidsverschil in de animatie
if(stappen<0){stappen=-stappen;}
for (int i=0;i<stappen;i++)
{
int x = (xb-xa)/stappen;
cout <<x<<endl;
int y = (yb-ya)/stappen;
//if(y<0){y=-y;}
cout << y << endl;
usleep(25000);line->setPoints(xa,ya,xa+(i*x),ya+(i*y));can->update();
}
line->setPoints(xa,ya,xb,yb);can->update();

}

void Widgeta::updatecanvas()
{	
	if (number==6){number=0; removealllines();tekstinfo->setText(tr ("Welcome,\n\nIn the frame next to this one you see someones living room. When you click on 'Next' you will see what happens with the light bundle that comes out of the lamp..."));}
	if (number == 1) {tekstinfo->setText(tr("A new lightbundel had left the lamp. But she has hit the water surfice...\nClick on 'Next' and you will see what happens.")); drawlines(linea, 300, 52, 412, 108 );}
	if (number == 2) {tekstinfo->setText(tr("The light bundle apparently reflected on the water surfice. But maybe something else happend also? ....\nPress 'Next' and you will know."));drawlines(lineb, 404 ,108 , 866 ,-25);} //onder zelfde hoek, terug
	if (number == 3) {tekstinfo->setText(tr("Something else happend indeed.\nThe lightbundel also went through the water. But she did change direction. And now she had hit the bottom of the aquarium..\nPress 'Next' and you will see what will happen with the lightbundle."));drawlines(linec, 404 ,108 , 465 ,230);}  //brekingsindex van water = 1.4
	if (number == 4) {tekstinfo->setText(tr("The lightbundel reflected again. Now she had hit the watersurface again...what will she do now?\n\nPress 'Next' and you will see what will happen with the lightbundle."));drawlines(lined, 460 ,230 , 515 ,120);} //onder zelfde hoek terug
	if (number == 5) {tekstinfo->setText(tr("The lightbundel went through the water. But she had changed directions again.\n\nNow you have seen all that can happen with a light bundle. If you want to see the animation again, just press 'Next'. You can also go the the second tab."));drawlines(linee, 505 ,128 , 967 ,-5);} //brekingsindex is weer 1.4; evenwijdig met lineb
	
	can->setAllChanged();
	can->update();
}

void Widgeta::makecanvas()
{
	can = new QCanvas(this,"can");
    	can->resize(1100,900);
     	canview = new QCanvasView(can,this,"canview");
	//QColor BackgroundColor(200,220,225);
	//can->setBackgroundColor(BackgroundColor);
	QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
	QString kamer_v3;
	kamer_v3.append(appBaseDir);
	kamer_v3.append("pictures/kamer_v3.jpg");
	QString water3;
	water3.append(appBaseDir);
	water3.append("pictures/water3.png");
	
	//QPixmap jan("/mnt/data/kde3.3/share/apps/edukator/pictures/kamer_v3.jpg", "JPEG", 0); //backgrounds
	QPixmap jan(kamer_v3, "JPEG", 0); //backgrounds
	can->setBackgroundPixmap(jan);

	
	pixarraywater = new QCanvasPixmapArray(water3,1);  //transparante layer, om stralen door water te laten gaan
	qcanvasspritewater = new QCanvasSprite(pixarraywater, can);
	qcanvasspritewater->move(0,0,0);
	//qcanvasspritelamp->rotate(20);
	qcanvasspritewater->setZ(10);
	//qcanvassprite->setFrame(1);
	qcanvasspritewater->show();
}


void Widgeta::makelines()
{
linea = new QCanvasLine(can); //abcde in volgorde van tekenen
lineb = new QCanvasLine(can);
linec = new QCanvasLine(can);
lined = new QCanvasLine(can);
linee = new QCanvasLine(can);
}

void Widgeta::removealllines()
{
linea->setPoints(0,0,0,0);
lineb->setPoints(0,0,0,0);
linec->setPoints(0,0,0,0);
lined->setPoints(0,0,0,0);
linee->setPoints(0,0,0,0);
can->update();
}

void Widgeta::makebuttons()
{
	//quit = new QPushButton( "&Afsluiten", this, "quit" );
    	//quit->setFont( QFont( "Nimbius Sans", 10, QFont::Bold) );
	//quit->setFixedWidth(170);
	nextbutton = new QPushButton( tr("&Next"), this, "nextbutton" );
   	nextbutton->setFont( QFont("Nimbius Sans", 10, QFont::Bold) );
	nextbutton->setFixedWidth(170);
	tostartbutton = new QPushButton( tr("To  &Start"), this, "tostartbutton" );
   	tostartbutton->setFont( QFont("Nimbius Sans", 10, QFont::Bold) );
	tostartbutton->setFixedWidth(170);
	/*connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );*/
	connect( nextbutton, SIGNAL(clicked()), this , SLOT(next()) );
	connect( tostartbutton, SIGNAL(clicked()), this , SLOT(tostart()) );
}

void Widgeta::makegrid()
{
	grid = new QGridLayout( this, 2, 2, 10, -1, "grid");
	canvas = new QVBoxLayout;
	info = new QVBoxLayout;
	//bovenaan = new QHBoxLayout;
	onderaan = new QHBoxLayout;
}

void Widgeta::addlayouts()
{
	grid->addMultiCellLayout(onderaan,2, 2, 1,2);
	//addChildLayout(canvas);
	//bovenaan->addChildLayout(info);
	//addLayout((addChildLayout(info)),1,1);
	grid->addLayout(info, 1 , 1);
	grid->addLayout(canvas, 1,2);
	grid->setColStretch( 2, 10 );
	
//	bovenaan->addLayout( info, 1, 1 );
}

void Widgeta::makelabels()
{
//	labelinfo = new QLabel ("Welkom,\n\nIn de kader hiernaast zie je\niemands woonkamer.\nWanneer je op 'next' klikt\n zal je zien wat er gebeurt\nmet een lichtstraal die\nvanuit de lamp vertrekt...", this, "labelinfo",0);
}

void Widgeta::maketekstinfo()
{
//mimesource = new QMimeSourceFactory();
//mimesource->setExtensionType("html", "text/html;charset=iso8859-1");
tekstinfo = new QTextBrowser(this, "tekstinfo");
tekstinfo->setFixedWidth(170);
tekstinfo->setText(tr("Welcome,\n\nIn the frame next to this one you see someones living room. When you click on 'Next' you will see what happens with the light bundle that comes out of the lamp..."));
//tekstinfo->setSource("./storyhowto.html");
}

void Widgeta::allesingrid()
{
	canvas->addWidget( canview );
    	info->addWidget( tekstinfo);
	//info->addWidget(nextbutton);
	//info->addWidget(quit);
	onderaan->addStretch( 1 );
	onderaan->addWidget(tostartbutton);
	onderaan->addWidget(nextbutton);
	//onderaan->addWidget(quit);
}
