/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "awidgetb.h"
#include <stdio.h>
#include <iostream>
using namespace std;

Widgetb::Widgetb( QWidget *parent, const char *name )
    : QWidget( parent, name )
{
  this->setFont(QFont( "Bitstream Vera Sans", 11, QFont::Normal));
  makecanvas();
  icopixmaps();
  makemessageboxes();
  makebuttons();
  makeframes();
  makeqradiobuttons();
  makelcdranges();
  makeqspinboxes();
  makeqlineedits();
  setstandardvalues();
  makepoints();
  makepolygons();
  maketeksten();
  makelabels();
  makegrids();
  makelayoutboxes();
  addlayouts();
  allesingrid();
  drawploygons();  
  connectall();
  doupdate();
  // zou moeten werken??? =>
  //QObject *gh = (QObject*)alphahoek->slider;
  //connect(gh, SIGNAL(sliderReleased()), this , SLOT(doupdate()) );
}

Widgetb::~Widgetb()
{}

void Widgetb::waardebrekingsindex()
{
  if ((qlineeditna->text()).toDouble() >= 1) {na=(qlineeditna->text()).toDouble();}
  if ((qlineeditna->text()).toDouble() < 1) {qmessageboxn->show();qlineeditna->setText(tr("Fault"));}
  if ((qlineeditnb->text()).toDouble() >= 1) {nb=(qlineeditnb->text()).toDouble();}
  if ((qlineeditnb->text()).toDouble() < 1) {qmessageboxn->show();qlineeditnb->setText(tr("Fault"));}
  if ((qlineeditnc->text()).toDouble() >= 1) {nc=(qlineeditnc->text()).toDouble();}
  if ((qlineeditnc->text()).toDouble() < 1) {qmessageboxn->show();qlineeditnc->setText(tr("Fault"));}
}
void Widgetb::checkinputs()
{
if(ya->value() >= yb->value()){qmessageboxya->show();ya->setValue(30);}
waardebrekingsindex();
}

void Widgetb::setlabels()
{
	betastringa.setNum(betagraden);
	betastringb.remove(0,9);
	betastringb.append(tr("Beta: "));
	betastringb.append(betastringa);
	betastringb.append("");
	
	gammastringa.setNum(gammagraden);
	gammastringb.remove(0,10);
	gammastringb.append(tr("Gamma: "));
	gammastringb.append(gammastringa);
	gammastringb.append("");

	labelbetaa->setText(betastringb);
	labelbetaa->setFixedHeight(24);
	labelgammaa->setText(gammastringb);
	labelgammaa->setFixedHeight(24);
	labelalpha->setFixedHeight(24);
}

void Widgetb::updatecoordinatenlijnen()
{
  vlaka->setPoints(0,yb->value(),1100,yb->value());
  vlakb->setPoints(0,yc,1100,yc);
  
  lijn->setPoints(xa,ya->value(),xb->value(),yb->value());
  lijn->setZ(10);
  lijnteruggekaatsta->setPoints(xb->value(), yb->value(),
                               xb->value()+((xb->value())-(xa)),ya->value() );
  lijnteruggekaatstb->setPoints(xc, yc, 2*xc-xb->value(),yb->value());
  normaala->setPoints(xb->value(), ya->value(), xb->value(), (yb->value())+breedterec->value());
  normaala->setZ(10);
  normaalb->setPoints(xc, yb->value(), xc, (yb->value())+breedterec->value()+(yb->value()-ya->value()));
  normaalb->setZ(10);
  normaalc->setPoints(2*xc-xb->value(), ya->value(),2*xc-xb->value() , (yb->value())+breedterec->value());
  
  lijnnabreking->setPoints(xb->value(), yb->value(), xc, yc);
  lijnnabreking->setZ(10);
  lijneindebegin->setPoints(2*xc-xb->value(),yb->value(),2*xc-xa,ya->value());
  lijneinde->setPoints(xc, yc, xd, yc+yb->value()-ya->value());
  lijneinde->setZ(10);
}

void Widgetb::updatecoordinatenteksten()
{
  teksta->setX((xa)+20);
  teksta->setY(ya->value()-5);
  tekstb->setX((xb->value())+20);
  tekstb->setY(yb->value());
  tekstna->setX((xb->value())+20);
  tekstna->setY(ya->value());
  tekstnb->setX(xc+10);
  tekstnb->setY(yb->value()+20);
  tekstnc->setX(2*xc-xb->value()+10);
  tekstnc->setY(ya->value());
  tekstvlaka->setX(20);
  tekstvlaka->setY(yb->value()-20);
  tekstvlakb->setX(20);
  tekstvlakb->setY(yc+5);
  
  tekstnaidx->setX(20);
  tekstnaidx->setY(((yb->value()+ya->value())/2)-10);
  tekstnbidx->setX(20);
  tekstnbidx->setY(((yb->value()+yc)/2)-10);
  tekstncidx->setX(20);
  tekstncidx->setY((yc+(yc+yb->value()-ya->value())-20)/2);
}

void Widgetb::setcoordninates()
{
	  updatecoordinatenlijnen();
          updatecoordinatenteksten();
	rec->setY(yb->value());
  	rec->setSize(1100, breedterec->value());
  	alphaellips->setX(xb->value()); 
  	alphaellips->setY(yb->value()); 
  	alphaellips->setZ(1);
  	alphaellips->setAngles(1440, (16*(graden->value()))+((4/15)*(minuten->value())));
  	betaellipsa->setX(xb->value()); 
  	betaellipsa->setY(yb->value()); 
  	betaellipsa->setZ(1);
  	betaellipsa->setAngles(4320, (16*(betagraden)));
  	betaellipsb->setX(xc); 
  	betaellipsb->setY(yc); 
  	betaellipsb->setZ(1);
  	betaellipsb->setAngles(1440, (16*(betagraden)));
	  
  	gammaellips->setX(xc); 
  	gammaellips->setY(yc); 
  	gammaellips->setZ(1);
  	gammaellips->setAngles(4320, (16*(gammagraden)));
	
	xaya->setX(xa);
	xaya->setY(ya->value());
	xaya->setZ(15);

	xbyb->setX(xb->value());
	xbyb->setY(yb->value());
	xbyb->setZ(15);	
}

void Widgetb::doupdate()
{
  checkinputs();
  degreestoradials();
  conabrekinga();
  conabrekingb();
  radialstodegrees();
  setlabels();
  setcoordninates();
  showlines();
  can->setAllChanged();
  can->update();
  //cout << "updated" << endl;
  //cout<<alpha<<" dit IS alpha"<<"nu komen de parameters xa:"<<xa<<" "<<"dit is beta: "<<beta<<" dit is xc: "<<xc<<" yc: "<<yc<<" nb: "<<nb<<" na: "<<na<<endl;
}

void Widgetb::slotdoupdate(int value)
{
doupdate();
}

void Widgetb::conabrekinga()
{
  /*aanschouw driehoek ABC met A(xa,ya) B(xb,ya) en C (xb, yb)
  aanschouw alpha de hoek tussen de invallende lichtstraal en de normaal
  alpha:
  tan aplha = AB / BC => ab = tan (alpha) BC
  bc: (yb-ya)
  ab: tan (alpha) BC
  xa: xb - AB
  aanschouw beta; de hoek tussen de normaal en de doorstralende lichtstraal
  wet van snellius = ni sin oi = nt sin ot met ni = na en nt = nb
  beta = ASIN ((na* sin alpha)/nb)
  aanschouw driehoek CED, met C(xb, yb) E(xb,-ya) en D(xc,-ya)
  xc = punt nodig om lijn te tekenen na breking, door glas
  xc:[ tan(BETA)*BC (BC = CE) ]+ xb
  */
  xa = int ( (xb->value())-((tan(alpha))*((yb->value())-(ya->value()))));
  beta=asin((na*sin(alpha))/nb);
  //als beta 90 word gaat de lichtstraal naar +INF, we kunnen dit niet tekenen.
  if(beta<=1.56)
  {
    yc =(yb->value()) + breedterec->value();
    xc = int (breedterec->value()*tan(beta)+(xb->value()));
  }
  else
  {
    //cout<<beta<<"=beta lichtstaal gaat naar +INF!! => we stellen beta gelijk aan 1.55"<<endl;qmessageboxinfbeta->show();beta=1.56;cout<<beta<<endl;
    //1e mogelijkheid
    yc =(yb->value()) + breedterec->value();
    xc = int (breedterec->value()*tan(beta)+(xb->value()));
    //2e mogelijkheid:
    //yc = yb->value();
    //xc = 1100;
  }
}

void Widgetb::conabrekingb()
{
  /*
  volgens snell's wet: alpha = gamma
  met gamma de hoek tussen de uitstralende lichtstraal (door glas gegaan) en de normaal
  aanschoud driehoek ABC; met A (xc,yc) C(xc,yc+breedterec) en B(xd;yc+breedterec)
  */
  //xd=(xb->value()-xa)+xc;
  // aanschouw driehoek abc met a(Xc,Yc) b(Xd,yc+yb-ya) en c(xc,yc+yb-ya)
  //wet van snellius ni*sinoi = nt*sinnt
  //oi = beta (eig: bij 2 evenwijdige maakt een snijdende rechte 2 gelijke hoeken)
  //ni = nb
  //nt = nc
  gamma = asin(nb*sin(beta)/nc);
  if(gamma<=1.56)
  {
    xd = int (tan(gamma)*(yb->value()-ya->value())+xc);
  }
  else
  {
   //cout<<gamma<<"=gamma lichtstaal gaat naar +INF!! => we stellen beta gelijk aan 1.55"<<endl;qmessageboxinfgamma->show();gamma=1.56;cout<<gamma<<endl;
   xd = int (tan(gamma)*(yb->value()-ya->value())+xc);
  }
  //cout <<"nc = "<<nc<<" gamma = "<<gamma<<endl;
  }

void Widgetb::degreestoradials()
{
double a,b,c;
a=graden->value();
b=minuten->value();
c=seconden->value();
alpha = (( (a)+((b)/60)+((c)/6000) )/180)*M_PI; //delen door 180 maal pi voor van deg naar rad te gaan; tussen haken; 60delig naar 10delig stelsel
//cout<<"dit is alpha in degreestoradials " <<alpha<<endl;
}

void Widgetb::radialstodegrees()
{
betagraden = int ((beta)*(180/M_PI));
gammagraden =int ( (gamma)*(180/M_PI));
}

void Widgetb::makecanvas()
{
  can = new QCanvas(this,"can");
  can->resize(1100,900);
  canview = new QCanvasView(can,this,"canview");
  QColor BackgroundColor(200,220,225);
  can->setBackgroundColor(BackgroundColor);
}

void Widgetb::icopixmaps()
{
QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
QString warning;
warning.append(appBaseDir);
warning.append("pictures/warning.gif");
qpixmapwarning = new QPixmap(warning, "GIF", 0);
}

void Widgetb::makemessageboxes()
{
  qmessageboxn = new QMessageBox(this);
  qmessageboxn->setText(tr("The refractive index must always\nbe bigger or equal to 1!!"));
  qmessageboxn->setIconPixmap(*qpixmapwarning);
  qmessageboxinfbeta = new QMessageBox(this);
  qmessageboxinfbeta->setText(tr("Beta approaches 90 (PI/2) to close\n=> the computer can't draw it accurate anymore."));
  qmessageboxinfbeta->setIconPixmap(*qpixmapwarning);
  qmessageboxinfgamma = new QMessageBox(this);
  qmessageboxinfgamma->setText(tr("Gamma approaches 90 (PI/2) to close\n=> the computer can't draw it accurate anymore."));
  qmessageboxinfgamma->setIconPixmap(*qpixmapwarning);
  qmessageboxya = new QMessageBox(this);
  qmessageboxya->setText(tr("The value of Ya may not be bigger than\nof equal to the value of Yb."));
  qmessageboxya->setIconPixmap(*qpixmapwarning);
}

void Widgetb::makebuttons()
{
  //quit = new QPushButton( "&Afsluiten", this, "quit" );
  //quit->setFont( QFont( "Nimbius Sans", 10, QFont::Bold ) );
  //quit->setFixedWidth(170);
  updatebutton = new QPushButton( tr("&Update"), this, "updatebutton" );
  updatebutton->setFont( QFont( "Nimbius Sans", 10, QFont::Bold ) );
  updatebutton->setFixedWidth(170);
  //connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
 // connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
  connect( updatebutton, SIGNAL(clicked()), this , SLOT(doupdate()) );
}

void Widgetb::makeframes()
{
    framelcds = new QFrame( this, "frame3" );
    framelcds->setFixedWidth(175);//framelcds
    framelcds->setFrameShape( QFrame::StyledPanel );
    framelcds->setFrameShadow( QFrame::Raised );    
       
    frameangles = new QFrame( this, "frame" );
    frameangles->setFixedHeight(105);
    frameangles->setFrameShape( QFrame::StyledPanel );
    frameangles->setFrameShadow( QFrame::Raised );
    
    frameindexes = new QFrame( this, "frame" );
    frameindexes->setFixedHeight(105);
    frameindexes->setFrameShape( QFrame::StyledPanel );
    frameindexes->setFrameShadow( QFrame::Raised );  
}

void Widgetb::makeqradiobuttons()
{
groupa = new QButtonGroup ( 3, Vertical, tr("Surface a"), this, "groupa");
groupa->setFixedWidth(155);
doorlaatbaara = new QRadioButton (tr("Lets through"), groupa, "doorlaatbaara" );
nietdoorlaatbaara = new QRadioButton (tr("Reflects"), groupa, "nietdoorlaatbaara" );
beidedoorlaatbaara = new QRadioButton (tr("Both"), groupa, "beide" );
groupa->setButton(2);

groupb = new QButtonGroup ( 3, Vertical, tr("Surface b"), this, "groupb");
groupb->setFixedWidth(155);
doorlaatbaarb = new QRadioButton (tr("Lets through"), groupb, "doorlaatbaarb" );
nietdoorlaatbaarb = new QRadioButton (tr("Reflects"), groupb, "nietdoorlaatbaarb" );
beidedoorlaatbaarb = new QRadioButton (tr("Both"), groupb, "beide" );
groupb->setButton(1);
}

void Widgetb::makeqlineedits()
{
  qlineeditna = new QLineEdit(frameindexes);
  qlineeditna->setFixedWidth(50);
  qlineeditnb = new QLineEdit(frameindexes);
  qlineeditnb->setFixedWidth(50);
  qlineeditnc = new QLineEdit(frameindexes);
  qlineeditnc->setFixedWidth(50);
}

void Widgetb::makeqspinboxes()
{
graden = new QSpinBox (0,88,1,frameangles,tr("degrees"));
graden->setFixedWidth(50);
minuten = new QSpinBox (0,60,1,frameangles,tr("minutes"));
minuten->setFixedWidth(50);
seconden = new QSpinBox (0,60,1,frameangles,tr("seconds"));
seconden->setFixedWidth(50);
}

void Widgetb::makepolygons()
{
  rec = new QCanvasRectangle (0, yb->value(), 1100, breedterec->value(), can );
  vlaka = new QCanvasLine(can);
  vlakb = new QCanvasLine(can);
  lijn = new QCanvasLine(can);
  lijnteruggekaatsta = new QCanvasLine (can);
  lijnteruggekaatstb = new QCanvasLine (can);
  normaala = new QCanvasLine (can);
  normaalb = new QCanvasLine (can);
  normaalc = new QCanvasLine (can);
  lijnnabreking = new QCanvasLine(can);
  lijneindebegin = new QCanvasLine(can);
  lijneinde = new QCanvasLine(can);
  alphaellips = new QCanvasEllipse(100,100,1440,(16*(graden->value()))+((4/15)*(minuten->value())), can);
  betaellipsa = new QCanvasEllipse(100,100,4320, (16*(betagraden)), can);
  betaellipsb = new QCanvasEllipse(100,100,1440, (16*(betagraden)), can);
  gammaellips = new QCanvasEllipse(100,100,4320, (16*(gammagraden)), can);
}

void Widgetb::makepoints()
{
xaya = new QCanvasEllipse(10,10,0,5760,can);
xbyb = new QCanvasEllipse(10,10,0,5760,can);
}

void Widgetb::showlines()
{
//QRADIOBUTTONS: welke lijnen moeten getekend worden
  if(groupa->selectedId()==0){lijnnabreking->setVisible(TRUE);lijneinde->setVisible(FALSE);lijnteruggekaatsta->setVisible(FALSE); lijnteruggekaatstb->setVisible(FALSE);lijneindebegin->setVisible(FALSE); tekenellipsen(1,1,0); tekennormalen(1,0,0);}
  if(groupa->selectedId()==1){lijnnabreking->setVisible(FALSE);lijneinde->setVisible(FALSE);lijnteruggekaatsta->setVisible(TRUE); lijnteruggekaatstb->setVisible(FALSE);lijneindebegin->setVisible(FALSE);tekenellipsen(1,0,0); tekennormalen(1,0,0);}
  if(groupa->selectedId()==2){lijnnabreking->setVisible(TRUE);lijneinde->setVisible(FALSE);lijnteruggekaatsta->setVisible(TRUE); lijnteruggekaatstb->setVisible(FALSE);lijneindebegin->setVisible(FALSE);tekenellipsen(1,1,0); tekennormalen(1,0,0);}
  
  if((groupa->selectedId()!=1))
  {
  if(groupb->selectedId()==0){lijneinde->setVisible(TRUE);lijnteruggekaatstb->setVisible(FALSE);lijneindebegin->setVisible(FALSE);tekenellipsen(1,1,1);tekennormalen(1,1,0);}
  if(groupb->selectedId()==1){lijneinde->setVisible(FALSE);lijnteruggekaatstb->setVisible(TRUE);lijneindebegin->setVisible(TRUE);tekenellipsen(1,1,0);tekennormalen(1,1,1);}
  if(groupb->selectedId()==2){lijneinde->setVisible(TRUE);lijnteruggekaatstb->setVisible(TRUE);lijneindebegin->setVisible(TRUE);tekenellipsen(1,1,1);tekennormalen(1,1,1);}
  }
}

void Widgetb::maketeksten()
{
  teksta = new QCanvasText("(Xa,Ya)", can);
  tekstb = new QCanvasText("(Xb,Yb)", can);
  tekstna = new QCanvasText(tr("normal"), can);
  tekstnb = new QCanvasText(tr("normal"), can);
  tekstnc = new QCanvasText(tr("normal"), can);
  tekstvlaka = new QCanvasText(tr("Surface a"), can);
  tekstvlakb = new QCanvasText(tr("Surface b"), can);
  tekstnaidx = new QCanvasText("na", can);
  tekstnbidx = new QCanvasText("nb", can);
  tekstncidx = new QCanvasText("nc", can);
}

void Widgetb::makegrids()
{
  grid = new QGridLayout( this, 3, 5, 10, -1, "grid");
  gridinframelcds = new QGridLayout( framelcds, 1, 1, 10, -1, "gridframelcds");
  gridinframeangles = new QGridLayout( frameangles, 3, 2,8, -1, "gridframeangles");
  gridinframeindexes = new QGridLayout( frameindexes, 3, 1,8 , -1, "gridframeindexes");
}

void Widgetb::makelayoutboxes()
{
	a = new QVBoxLayout;
        b = new QVBoxLayout;
    	nbox = new QVBoxLayout;
  	groupabox = new QVBoxLayout;
  	groupbbox = new QHBoxLayout;
  	alphabox = new QVBoxLayout;
	emptyright = new QHBoxLayout;
	//gradenbox = new QHBoxLayout;
	//minutenbox = new QHBoxLayout;
	//secondenbox = new QHBoxLayout;
	//betabox = new QHBoxLayout;
	//gammabox = new QHBoxLayout;
	onderaan = new QHBoxLayout;
	layoutframelcds = new QVBoxLayout;
	layoutframeanglesa = new QVBoxLayout;
	layoutframeanglesb = new QHBoxLayout;
	layoutframeindexesa = new QHBoxLayout;
	layoutframeindexesb = new QHBoxLayout;
	layoutframeindexesc = new QHBoxLayout;
}

void Widgetb::addlayouts()
{	
	grid->addLayout(nbox,0,0);
	//grid->addLayout(nbbox,1,0);
	//grid->addLayout(ncbox,2,0);
	grid->addLayout(groupabox,0,1);
	grid->addLayout(groupbbox,0,2);
	grid->addLayout(alphabox,0,3);
	grid->addLayout(emptyright,0,4);
//	grid->addLayout(gradenbox,0,4);
//	grid->addLayout(minutenbox,1,4);
//	grid->addLayout(secondenbox,2,4);
	//grid->addLayout(betabox,0,5);
	//grid->addLayout(gammabox, 1,5);
	grid->addMultiCellLayout(onderaan, 2,2,0,4);
	grid->addLayout(a,1,0);
	grid->addMultiCellLayout(b,1,1,1,4);
	grid->setColStretch( 0, 0 );
	grid->setColStretch( 1, 0 );
	grid->setColStretch( 2, 0 );
	grid->setColStretch( 3, 0 );
	grid->setColStretch( 4, 10 );
	
	gridinframelcds->addLayout(layoutframelcds,0,0); 
	gridinframeangles->addMultiCellLayout(layoutframeanglesa,0,3,0,0);
	gridinframeangles->addLayout(layoutframeanglesb,0,1); 
	gridinframeindexes->addLayout(layoutframeindexesa,0,0);
	gridinframeindexes->addLayout(layoutframeindexesb,1,0);
	gridinframeindexes->addLayout(layoutframeindexesc,2,0);
}

void Widgetb::makelabels()
{
  labelalpha = new QLabel ("Alpha  ---> ", frameangles, "labelalpha",0);
  labelalpha->setPaletteBackgroundColor(yellow);
  labelbetaa = new QLabel ("betastringb", frameangles, "labelbetab",0);
  labelbetaa->setPaletteBackgroundColor(white);
  labelgammaa = new QLabel ("gammastringb", frameangles, "labelbetab",0);
  labelgammaa->setPaletteBackgroundColor(green);
  
  labelgraden = new QLabel ("  ", frameangles, "labelgraden",0);
  labelgraden->setAlignment(AlignTop);
  labelminuten = new QLabel ("'  ", frameangles, "labelminuten",0);
  labelminuten->setAlignment(AlignTop);
  labelseconden = new QLabel ("''  ", frameangles, "labelseconden",0);
  labelseconden->setAlignment(AlignTop);
  
  labelna = new QLabel (tr("Refractivdidx na"), frameindexes, "labelna",0);
  labelnb = new QLabel (tr("Refractivdidx nc"), frameindexes, "labelnb",0);
  labelnc = new QLabel (tr("Refractivdidx nc"), frameindexes, "labelnc",0);
}

void Widgetb::tekennormalen(int norma, int normb, int normc)
{
tekstna->setVisible(FALSE);tekstnb->setVisible(FALSE);tekstnc->setVisible(FALSE);
normaala->setVisible(FALSE);normaalb->setVisible(FALSE);normaalc->setVisible(FALSE);
if (norma==1) {normaala->setVisible(TRUE);tekstna->setVisible(TRUE);}
if (normb==1) {normaalb->setVisible(TRUE);tekstnb->setVisible(TRUE);}
if (normc==1) {normaalc->setVisible(TRUE);tekstnc->setVisible(TRUE);}
}

void Widgetb::tekenellipsen(int alpha, int beta, int gamma)
{
alphaellips->setVisible(FALSE);betaellipsa->setVisible(FALSE);betaellipsb->setVisible(FALSE); gammaellips->setVisible(FALSE);
labelbetaa->hide();labelgammaa->hide();
if (alpha==1) {alphaellips->setVisible(TRUE);}
if (beta==1) {betaellipsa->setVisible(TRUE);betaellipsb->setVisible(TRUE);labelbetaa->show();}
if (gamma==1) {gammaellips->setVisible(TRUE);labelgammaa->show();}
}

void Widgetb::allesinframelcds()
{
	layoutframelcds->addWidget(breedterec);
  	layoutframelcds->addStretch( 0 );
  	layoutframelcds->addWidget(xb);
  	layoutframelcds->addStretch( 0 );
  	layoutframelcds->addWidget(ya);
  	layoutframelcds->addStretch( 0 );
  	layoutframelcds->addWidget(yb);
}

void Widgetb::allesinframeangles()
{
layoutframeanglesa->setSpacing(5);
layoutframeanglesa->addWidget(labelalpha);
layoutframeanglesa->addWidget(labelbetaa);
layoutframeanglesa->addWidget(labelgammaa);
layoutframeanglesa->addStretch(1);
layoutframeanglesb->setSpacing(0);
layoutframeanglesb->addWidget(graden);
layoutframeanglesb->addWidget(labelgraden);
layoutframeanglesb->addWidget(minuten);
layoutframeanglesb->addWidget(labelminuten);
layoutframeanglesb->addWidget(seconden);
layoutframeanglesb->addWidget(labelseconden);
//layoutframeanglesb->addStretch(10);
}

void Widgetb::allesinframeindexes()
{
layoutframeindexesa->setSpacing(0);
layoutframeindexesb->setSpacing(0);
layoutframeindexesc->setSpacing(0);
layoutframeindexesa->addWidget(labelna);
layoutframeindexesa->addWidget( qlineeditna );
layoutframeindexesb->addWidget(labelnb);
layoutframeindexesb->addWidget( qlineeditnb );
layoutframeindexesc->addWidget(labelnc);
layoutframeindexesc->addWidget( qlineeditnc );
}

void Widgetb::allesingrid()
{
allesinframelcds();
allesinframeangles();
allesinframeindexes();
  
  nbox->addStretch(1);
  nbox->addWidget(frameindexes);
  
  groupabox->addWidget(groupa);
  groupbbox->addWidget(groupb);
  
  //alphabox->addWidget(labelalpha);
  //alphabox->addWidget(labelbetaa);
  //alphabox->addWidget(labelgammaa);
  
  alphabox->addStretch(1);
  alphabox->addWidget(frameangles);
      
  emptyright->addStretch(1);
/*  gradenbox->setSpacing(0);
  gradenbox->addWidget(graden);
  gradenbox->addWidget(labelgraden);
  gradenbox->addWidget(minuten);
  gradenbox->addWidget(labelminuten);
  gradenbox->addWidget(seconden);
  gradenbox->addWidget(labelseconden);
  gradenbox->addStretch(10);
   */
  onderaan->addStretch(1);
  onderaan->addWidget(updatebutton);
  //onderaan->addWidget(quit);
  
  a->setSpacing(0);
  a->addWidget(framelcds);
  b->addWidget(canview);  

  //grid->setColStretch( , 10 );
}

void Widgetb::makelcdranges()
{
  breedterec = new LCDRange(tr("Distance between\nSurface a and b: "),framelcds, "breedterec" );
  xb = new LCDRange(tr("Coordinates Xb: "), framelcds, "xb" );
  ya = new LCDRange(tr("Coordinates Ya: "), framelcds, "ya" );
  yb = new LCDRange(tr("Coordinates Yb: "), framelcds, "yb" ); 
}

void Widgetb::connectall()
{
connect(breedterec, SIGNAL(valueChanged(int)), this , SLOT(slotdoupdate(int)) );
connect(xb, SIGNAL(valueChanged(int)), this , SLOT(slotdoupdate(int)) );
connect(ya, SIGNAL(valueChanged(int)), this , SLOT(slotdoupdate(int)) );
connect(yb, SIGNAL(valueChanged(int)), this , SLOT(slotdoupdate(int)) );
connect(graden, SIGNAL(valueChanged(int)), this , SLOT(slotdoupdate(int)) );
connect(minuten, SIGNAL(valueChanged(int)), this , SLOT(slotdoupdate(int)) );
connect(seconden, SIGNAL(valueChanged(int)), this , SLOT(slotdoupdate(int)) );
}

void Widgetb::drawploygons()
{
  rec->setBrush(QBrush(QColor(90,100,120),BDiagPattern ));
  rec->setPen(QPen(green,5,PenStyle(NoPen)));
  rec->show();
  
  vlaka->setPen(QPen(QColor(90,100,120), 5, PenStyle(DashDotLine)));
  vlaka->show();
  vlakb->setPen(QPen(QColor(90,100,120), 5, PenStyle(DashDotLine)));
  vlakb->show();
  
  normaala->setPen(QPen(QColor(90,100,120),5, PenStyle(DotLine)));
  normaala->show();
  normaalb->setPen(QPen(QColor(90,100,120),5, PenStyle(DotLine)));
  normaalb->show();
  normaalc->setPen(QPen(QColor(90,100,120),5, PenStyle(DotLine)));
  normaalc->show();
  
  lijn->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));
  lijn->show();
  
  lijnteruggekaatsta->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));
  lijnteruggekaatsta->show();
  
  lijnteruggekaatstb->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));
  lijnteruggekaatstb->show();
  
  lijnnabreking->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));
  lijnnabreking->show();
  
  lijneindebegin->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));
  lijneindebegin->show();
  
  lijneinde->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));
  lijneinde->show();
  
  alphaellips->setBrush(QBrush(yellow,SolidPattern ));
  alphaellips->setPen(QPen(green,5,PenStyle(NoPen)));
  alphaellips->show();
  
  betaellipsa->setBrush(QBrush(white,SolidPattern ));
  betaellipsa->setPen(QPen(green,5,PenStyle(NoPen)));
  betaellipsa->show();
  
  betaellipsb->setBrush(QBrush(white,SolidPattern ));
  betaellipsb->setPen(QPen(green,5,PenStyle(NoPen)));
  betaellipsb->show();
  
  gammaellips->setBrush(QBrush(green,SolidPattern ));
  gammaellips->setPen(QPen(green,5,PenStyle(NoPen)));
  gammaellips->show();
  
  xaya->setBrush(QBrush(red,SolidPattern ));
  xaya->setPen(QPen(green,5,PenStyle(NoPen)));
  xaya->show();
  
  xbyb->setBrush(QBrush(red,SolidPattern ));
  xbyb->setPen(QPen(green,5,PenStyle(NoPen)));
  xbyb->show();
  
  teksta->setTextFlags(AlignTop);
  teksta->setColor(red);
  tekstb->setColor(red);
  
  teksta->show();
  tekstb->show();
  tekstna->show();
  tekstnb->show();
  tekstnc->show();
  tekstvlaka->show();
  tekstvlakb->show();
  tekstnaidx->show();
  tekstnbidx->show();
  tekstncidx->show();
}


void Widgetb::setstandardvalues()
{
  nb = 1.563;
  na = 1;
  nc = 1;
  graden->setValue(52);
  minuten->setValue(50);
  seconden->setValue(25);
  breedterec->setValue(110);
  xb->setValue(320);
  yb->setValue(190);
  ya->setValue(30);
  
qlineeditncnumber.setNum(nc);
qlineeditnanumber.setNum(na);
qlineeditnbnumber.setNum(nb);
qlineeditna->setText(qlineeditnanumber);
qlineeditnb->setText(qlineeditnbnumber);
qlineeditnc->setText(qlineeditncnumber);
}
