#ifndef AWIDGETB_H
#define  AWIDGETB_H

#include <qwidget.h>
#include <qpushbutton.h>
#include <qlcdnumber.h>
#include <qfont.h>
#include <qlayout.h>

#include <qradiobutton.h> 
#include <qbuttongroup.h> 

#include "lcdrange.h"
#include <qcanvas.h> 

#include <qcolor.h> 
//#include <qpainter.h>
#include <qlabel.h> 
#include <math.h>
#include <qlineedit.h> 
#include <qmessagebox.h> 
#include <qpixmap.h>
#include <qspinbox.h> 
#include <qframe.h> 

//mogen eigelijk weg:
//#include <qspinbox.h> 
//#include <qslider.h> 
#include <kglobal.h>
#include <klocale.h>
#include <kstandarddirs.h>
#include <kcmdlineargs.h>

class Widgetb: public QWidget
{
	Q_OBJECT
public:
	Widgetb( QWidget *parent, const char *name);	
	~Widgetb();
	
	double nc, nb, na;
	int xa, yc;
	int xc; //punt nodig om lijn te tekenen door breking, door 'glas'
	int xd; //punt nodig om lijn te tekenen na breking, door 'glas'
	double alpha, beta, gamma;
	int betagraden, gammagraden;
	void conabrekinga();
	void conabrekingb();
	void setstandardvalues(); //standaard waarden/ start waarden worden er gezet
	void icopixmaps(); //pixmaps worden er omgezet in Qicons
	void makemessageboxes(); //info boxes worden er aangemaak
	void makebuttons(); //buttons worden er aangemaakt en geconnect!
	void makegrids(); // maak grid aan en maak de layouts aan.
	void addlayouts(); // voeg layouts toe aan de grid gemaakt in makegrid.
	void makelayoutboxes();
	void makelabels(); // maak labels
	void allesingrid(); // plaats alles in de grid
	void allesinframelcds(); //plaats alles in de frame waar de lcds en sliders zitten
	void allesinframeangles(); //plaats alles in de frame waar de labels van de hoeken enzo zitten
	void allesinframeindexes(); //plaats alles in de frame waar de labels van indexes zitten
	void makelcdranges(); //naam spreekt voor zich; lcdrange is apparte cpp en h file, maakt lcd en slider
	void makeqlineedits(); //spreekt voor zich
	void makecanvas(); //maakt canvas en canview en zet kleur en dergelijke
	//void makelinestyles(); //maakt kleur en type en style aan
	void makepolygons(); //maakt de lijnen en rechthoek enzo aan
	// void drawpolygons(QPen, QPen); //teken ze
	void makepoints();
	void maketeksten(); //"normaal" enzp
	void makeqspinboxes();
	void degreestoradials(); //voor alpha
	void radialstodegrees(); // voor beta
	void makeqradiobuttons(); //maakt de qradiobuttons, voor doorlaatbaarheid bijvoorbeeld	
	void tekennormalen(int norma,int normb,int normc); //welke normalen zijn nogig?
	void tekenellipsen(int alpha, int beta, int gamma); //welke ellipsen zijn nodig
	void showlines(); //welke lijnen moeten getekend worden?
	void updatecoordinatenlijnen(); //in update, nieuwe coordinaten van de lijnen
	void updatecoordinatenteksten(); //in update, nieuwe coordinaten van de QCanvasTexten
	void makeframes(); //maak de frames zoals framelcds
	void drawploygons(); //teken de lijnen en de rechthoek
	void checkinputs(); //checkt de inputs, voorbeeld, ya en yb
	void setlabels(); // zet de waarde van de labels, gamma, beta
	void setcoordninates(); //zet de nieuwe coordinaten van objecten in doupdate()	
	void connectall();
	
	QGridLayout *grid;
	QGridLayout *gridinframelcds;
	QGridLayout *gridinframeangles;
	QGridLayout *gridinframeindexes;
	
	LCDRange *breedterec;
	LCDRange *xb;
	LCDRange *ya;
	LCDRange *yb;
		
	QVBoxLayout *layoutframelcds;
	QVBoxLayout *layoutframeanglesa;
	QHBoxLayout *layoutframeanglesb;
	QHBoxLayout *layoutframeindexesa;
	QHBoxLayout *layoutframeindexesb;
	QHBoxLayout *layoutframeindexesc;
	QVBoxLayout *a; //labels en lcds links
    	QVBoxLayout *b; //canvas 
	
	QVBoxLayout *nbox; //na nb nc worden er ingevoerd: frame
    	QVBoxLayout *groupabox; //checkbox a
    	QHBoxLayout *groupbbox; //checkbox b
	QVBoxLayout *alphabox; //label
	QHBoxLayout *emptyright; //spacer
	//QHBoxLayout *gradenbox; //label en input
	//QHBoxLayout *minutenbox;
	//QHBoxLayout *secondenbox;
	QHBoxLayout *betabox; //beta is hoe groot?
	QHBoxLayout *gammabox; //gamma is hoe groot?
	QHBoxLayout *onderaan; //onderaan met knoppen
		
	QCanvas *can;
    	QCanvasView *canview;
    	QCanvasRectangle *rec;
	QCanvasLine *vlaka;
	QCanvasLine *vlakb;
    	QCanvasLine *lijn;
	QCanvasLine *lijnteruggekaatsta;
	QCanvasLine *normaala;
	QCanvasLine *normaalb;
	QCanvasLine *normaalc;
	QCanvasLine *lijnnabreking;
	QCanvasLine *lijnteruggekaatstb;
	QCanvasLine *lijneindebegin;
	QCanvasLine *lijneinde;
			
	QCanvasEllipse *alphaellips;
	QCanvasEllipse *betaellipsa;
	QCanvasEllipse *betaellipsb;
	QCanvasEllipse *gammaellips;
	
	//punten
	QCanvasEllipse *xaya;
	QCanvasEllipse *xbyb;
	
	//QPushButton *quit;
	QPushButton *updatebutton;
	//QPushButton *alphamaalpibutton;	
	
	//teksten
	//QLabel *labelbreedterec;
	QLabel *labelalpha;
//	QLabel *labelya;
//	QLabel *labelxb;
//	QLabel *labelyb;
	QLabel *labelgraden;
	QLabel *labelminuten;
	QLabel *labelseconden;
	QLabel *labelbetaa;
	QLabel *labelgammaa;
	QLabel *labelna;
	QLabel *labelnb;
	QLabel *labelnc;
	//QLabel *labeldoorlaatbaarheid;
		
	QCanvasText *teksta;
	QCanvasText *tekstb;
	QCanvasText *tekstna;
	QCanvasText *tekstnb;
	QCanvasText *tekstnc;
	QCanvasText *tekstvlaka;
	QCanvasText *tekstvlakb;
	QCanvasText *tekstnaidx;
	QCanvasText *tekstnbidx;
	QCanvasText *tekstncidx;
	
	//inputs
	QLineEdit *qlineeditna;
	QString qlineeditnanumber;
	QLineEdit *qlineeditnb;
	QString qlineeditnbnumber;
	QLineEdit *qlineeditnc;
	QString qlineeditncnumber;	
	QString betastringa;
	QString betastringb;
	QString gammastringa;
	QString gammastringb;
	
	
	QSpinBox *graden;
	QSpinBox *minuten;
	QSpinBox *seconden;
	
	//radiobutton
	QButtonGroup *groupa;
	QRadioButton *doorlaatbaara;
	QRadioButton *nietdoorlaatbaara;
	QRadioButton *beidedoorlaatbaara;
	
	QButtonGroup *groupb;
	QRadioButton *doorlaatbaarb;
	QRadioButton *nietdoorlaatbaarb;
	QRadioButton *beidedoorlaatbaarb;
	
	//messageboxen
	QMessageBox *qmessageboxalpha;
	QMessageBox *qmessageboxn;
	QMessageBox *qmessageboxinfbeta; //inf van oneindig;als lichtstraal naar +INF gaat kan comp ze niet tekenen
	QMessageBox *qmessageboxinfgamma; //inf van oneindig;als lichtstraal naar +INF gaat kan comp ze niet tekenen
	QMessageBox *qmessageboxya;
	
	QPixmap *qpixmapwarning;
	
	//frame
	QFrame *framelcds;
	QFrame *frameangles;
	QFrame *frameindexes;
	
public slots:
	void doupdate();
	void slotdoupdate(int value);
	void waardebrekingsindex();
	
};
#endif // AWIDGETB_H
