/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "bwidgeta.h"
#include <stdio.h>
#include <iostream>

using namespace std;

bWidgeta::bWidgeta( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
	// "Nimbius Sans"
	this->setFont(QFont( "Bitstream Vera Sans", 12, QFont::Normal));
	setstandardsa();
	makelabels();
	maketekstinfo();
	makecanvas();
	makelines();
	makepoints();
	makegrid();
	addlayouts();
	allesingrid();	  
	
	QColor pen(255,230,65);
  	QPen solidline(pen, 25);
	solidline.setStyle (SolidLine);
}

bWidgeta::~bWidgeta()
{}

void bWidgeta::setstandardsa()
{
number = 0;
}

void bWidgeta::calculate()
{
/*double discriminanta= pointa->x()-pointc->x();
double discriminantb= pointb->x()-pointc->x();
double discriminantc= pointa->x()-pointd->x();
double discriminantd= pointb->x()-pointd->x();
dubbelverhouding = (discriminanta*discriminantd)/(discriminantc*discriminantb); //formule met discriminanten met z = 1*/
//cout << dubbelverhouding<<endl;
/** Oude manier is nu gedeselecteerd, maar was even goed */
dubbelverhouding = ((pointc->x()-pointa->x())/(pointc->x()-pointb->x()))/((pointd->x()-pointa->x())/(pointd->x()-pointb->x()));
cout << dubbelverhouding<<endl;
//cout <<"dubbelverhouding"<<dubbelverhouding<<endl;
}

void bWidgeta::doupdate()
{
//cout <<"laten we wat updaten"<<endl;
number++;
if (number == 1) {pointa->setX(canview->getX());pointa->show();labela->hide();labelb->hide();labelc->hide();labeld->hide();labela->setX(canview->getX());labela->show();}
if (number == 2) {pointb->setX(canview->getX());pointb->show();labelb->hide();labelc->hide();labeld->hide();labelb->setX(canview->getX()); labelb->show();}
if (number == 3) {pointc->setX(canview->getX());pointc->show();labelc->hide();labeld->hide();labelc->setX(canview->getX());labelc->show();}
if (number == 4) {pointd->setX(canview->getX());pointd->show();calculate(); labeldubbelverhoudingb->setNum(dubbelverhouding);labeldubbelverhoudingb->show();labeld->hide();labeld->setX(canview->getX());labeld->show();}
if (number > 4) { number = 0; labeldubbelverhoudingb->hide(); pointa->hide();pointb->hide();  pointc->hide(); pointd->hide();number++;pointa->setX(canview->getX());pointa->show();labela->hide();labelb->hide();labelc->hide();labeld->hide();labela->setX(canview->getX());labela->show();}

can->setAllChanged();
can->update();
}

void bWidgeta::drawscale(int lengte)
{
for(int i=0;i<1280;i=i+50)
{
QString string;
string.setNum(i);
line = new QCanvasLine(can);
line->setPoints(i, 240+(lengte/2),i,240-(lengte/2));
label = new QCanvasText(string, can);
label->setX(i);
label->setY(240+lengte);
line->show();
label->show();
}
}

void bWidgeta::makepoints()
{
pointa = new QCanvasEllipse(10,10,0,360*16, can);
pointa->setBrush(QBrush(red,SolidPattern ));
pointa->setPen(QPen(green,5,PenStyle(NoPen)));
pointa->setZ(1);
pointa->setY(240);

pointb = new QCanvasEllipse(10,10,0,360*16, can);
pointb->setBrush(QBrush(red,SolidPattern ));
pointb->setPen(QPen(green,5,PenStyle(NoPen)));
pointb->setZ(1);
pointb->setY(240);

pointc = new QCanvasEllipse(10,10,0,360*16, can);
pointc->setBrush(QBrush(red,SolidPattern ));
pointc->setPen(QPen(green,5,PenStyle(NoPen)));
pointc->setZ(1);
pointc->setY(240);

pointd = new QCanvasEllipse(10,10,0,360*16, can);
pointd->setBrush(QBrush(red,SolidPattern ));
pointd->setPen(QPen(green,5,PenStyle(NoPen)));
pointd->setZ(1);
pointd->setY(240);

}
void bWidgeta::makecanvas()
{
	can = new QCanvas(this,"can");
    	can->resize(1100,900);
     	canview = new DisplayCanvasView(can,this,"canview");
	QColor BackgroundColor(200,220,225);
	can->setBackgroundColor(BackgroundColor);
	connect (canview, SIGNAL(ClickValueChanged( )), this, SLOT(doupdate()));
	drawscale(20);
}


void  bWidgeta::makelines()
{
xas = new QCanvasLine(can);
xas->setPoints(0,240,1280,240);
xas->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));
xas->show();

labela = new QCanvasText("A", can);labela->hide();labela->setY(210);
labelb = new QCanvasText("B", can);labelb->hide();labelb->setY(210);
labelc = new QCanvasText("C", can);labelc->hide();labelc->setY(210);
labeld = new QCanvasText("D", can);labeld->hide();labeld->setY(210);
  
}


// void bWidgeta::makebuttons()
// {
// 	quit = new QPushButton( "&Afsluiten", this, "quit" );
//     	quit->setFont( QFont( "Nimbius Sans", 10, QFont::Bold) );
// 	quit->setFixedWidth(170);
// 	connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
// }

void bWidgeta::makegrid()
{
	grid = new QGridLayout( this, 2, 2, 10, -1, "grid");
	canvas = new QVBoxLayout;
	info = new QVBoxLayout;
	bovenaan = new QHBoxLayout;
// 	onderaan = new QHBoxLayout;
}

void bWidgeta::addlayouts()
{
	//grid->addMultiCellLayout(onderaan,2, 2, 1,2);
	//addChildLayout(canvas);
	//bovenaan->addChildLayout(info);
	//addLayout((addChildLayout(info)),1,1);
	grid->addLayout(info, 1 , 1);
	grid->addLayout(canvas, 1,2);
	grid->setColStretch( 2, 10 );
	
//	bovenaan->addLayout( info, 1, 1 );
}

void bWidgeta::makelabels()
{
 labeldubbelverhoudinga = new QLabel (tr("Dubblerate"), this, "label",0);
 labeldubbelverhoudingb = new QLabel ("", this, "label",0);
//	labelinfo = new QLabel ("Welkom,\n\nIn de kader hiernaast zie je\niemands woonkamer.\nWanneer je op 'next' klikt\n zal je zien wat er gebeurt\nmet een lichtstraal die\nvanuit de lamp vertrekt...", this, "labelinfo",0);
}

void bWidgeta::maketekstinfo()
{
//mimesource = new QMimeSourceFactory();
//mimesource->setExtensionType("html", "text/html;charset=iso8859-1");
tekstinfo = new QTextBrowser(this, "tekstinfo");
tekstinfo->setFixedWidth(170);
tekstinfo->setFixedHeight(280);
tekstinfo->setText(tr("Welcome,\n\nClick on the frame next to this one and appoint 4 points. The dubblerate (ABCD) will be calculated. When a 5th point is appointed it will be the first of a new dubblerate."));
//tekstinfo->setSource("./storyhowto.html");
}

void bWidgeta::allesingrid()
{
	canvas->addWidget( canview );
    	info->addWidget( tekstinfo);
	info->addWidget(  labeldubbelverhoudinga);
	info->addWidget(  labeldubbelverhoudingb);
	info->addStretch(1);
	//info->addWidget(nextbutton);
	//info->addWidget(quit);
// 	onderaan->addStretch( 1 );
// 	onderaan->addWidget(quit);
}
