
/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "bwidgetb.h"
#include <stdio.h>
#include <iostream>

using namespace std;

bWidgetb::bWidgetb( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
	// "Nimbius Sans"
	this->setFont(QFont( "Bitstream Vera Sans", 12, QFont::Normal));
	setstandardsa();
	makelabels();
	maketekstinfo();
	makecanvas();
	makelines();
	makepoints();
// 	makebuttons();
	makegrid();
	addlayouts();
	allesingrid();	  
	
	QColor pen(255,230,65);
  	QPen solidline(pen, 25);
	solidline.setStyle (SolidLine);
}

bWidgetb::~bWidgetb()
{}

void bWidgetb::setstandardsa()
{
number = 0;
}

void bWidgetb::calculate()
{
double discriminanta=givemeu(pointca->x(),pointca->y(),pointcb->x(),pointcb->y())-givemeu(pointaa->x(),pointaa->y(),pointab->x(),pointab->y());
double discriminantb=givemeu(pointca->x(),pointca->y(),pointcb->x(),pointcb->y())-givemeu(pointba->x(),pointba->y(),pointbb->x(),pointbb->y());
double discriminantc=givemeu(pointda->x(),pointda->y(),pointdb->x(),pointdb->y())-givemeu(pointaa->x(),pointaa->y(),pointab->x(),pointab->y());
double discriminantd=givemeu(pointda->x(),pointda->y(),pointdb->x(),pointdb->y())-givemeu(pointba->x(),pointba->y(),pointbb->x(),pointbb->y());
dubbelverhouding = (discriminanta*discriminantd)/(discriminantc*discriminantb); //formule met discriminanten met z = 1
//cout <<"dubbelverhouding"<<dubbelverhouding<<endl;
}

void bWidgetb::calculatecrosspoint()
{
crosspointz =int(  ((pointaa->y()-pointab->y())*(pointbb->x()-pointba->x()))-( (pointba->y()-pointbb->y())*(pointab->x()-pointaa->x()) )   );
// crosspointx = int(       ((pointab->x()-pointaa->x())*( (pointbb->x()*pointba->y())-(pointbb->y()*pointba->x()) )) - ( (pointbb->x()-pointba->x())*( (pointab->x()*pointaa->y())-(pointab->y()*pointaa->x()) ) )       );
// crosspointx= -(crosspointx/crosspointz);
crosspointx = givemecrosspointx(pointaa->x(),pointaa->y(),pointab->x(),pointab->y(),pointba->x(),pointba->y(),pointbb->x(),pointbb->y() );
crosspointy = givemecrosspointy(pointaa->x(),pointaa->y(),pointab->x(),pointab->y(),pointba->x(),pointba->y(),pointbb->x(),pointbb->y() );
// crosspointy = int(  (((pointab->x()*pointaa->y())-(pointab->y()*pointaa->x()) )*(pointba->y()-pointbb->y())) -  (((pointbb->x()*pointba->y())-(pointbb->y()*pointba->x()) )*(pointaa->y()-pointab->y()))  );
// crosspointy = -(crosspointy/crosspointz);
//cout<<"x = "<<crosspointx<<"y = "<<crosspointy<<endl;
}

double bWidgetb::calculaterico(double xaa, double yaa, double xab, double yab)
{
double rico = 0; 
drawrico = 10;
if (xab-xaa == 0) {drawrico = 0; rico = 0; }
if (yab-yaa == 0) {drawrico = 0; rico = 0;}
//if (xab-xaa < (2/100) || xab-xaa > -(2/100)) {drawrico = 0; rico = 0;cout << "olakjur"<<endl;}
//if (yab-yaa< (2/100) || yab-yaa > -(2/100)) {drawrico = 0; rico = 0;cout << "olakjur"<<endl;}
if (drawrico != 0 ) {rico = (yab-yaa)/(xab-xaa);}
if (rico < (0.015) && rico > (-0.015)) {drawrico = 0; rico = 0;  }
if (rico > 100 || rico < -100) {drawrico = 0; rico = 0;  }
//cout <<"rico = "<<rico<<endl;
return rico;
}

int bWidgetb::givemecrosspointx(double xaa, double yaa, double xab, double yab, double xba, double yba, double xbb, double ybb)
{
int pointx;
//pointz = int(  (yaa-yab)*(xbb-xba)-(yba-ybb)*(xab-xaa) );
pointx =- int (  ((xab-xaa)*((xbb*yba)-(ybb*xba))- (xbb-xba)*((xab*yaa)-(yab*xaa))) /  ((yaa-yab)*(xbb-xba)-(yba-ybb)*(xab-xaa)));
//if (pointx<0) {pointx = -pointx;}
return pointx;
}

int bWidgetb::givemecrosspointy(double xaa, double yaa, double xab, double yab, double xba, double yba, double xbb, double ybb)
{
int pointy;
//pointz = int(  (yaa-yab)*(xbb-xba)-(yba-ybb)*(xab-xaa) );
pointy = -int (  (((xab*yaa)-(yab*xaa))* (yba-ybb)- ((xbb*yba)-(ybb*xba))* (yaa-yab)) /  ((yaa-yab)*(xbb-xba)-(yba-ybb)*(xab-xaa)));
//if (pointy<0) {pointy = -pointy;}
return pointy;
}

double bWidgetb::givemeu(double xa, double ya, double xb, double yb)
{
double u;
u = (ya-yb)/(xa*yb-ya*xb);
return u;
}

double bWidgetb::givemev(double xa, double ya, double xb, double yb)
{
double  v;
v = (xb-xa)/(xa*yb-ya*xb);
return v;
}

void bWidgetb::doupdate()
{
//cout <<"laten we wat updaten"<<endl;
number++;
if (number == 1) {pointaa->setX(canview->getXUnMod());pointaa->setY(canview->getY());pointaa->show();}
if (number == 2) {pointba->setX(canview->getXUnMod());pointba->setY(canview->getY());pointba->show();}
if (number == 3) {pointca->setX(canview->getXUnMod());pointca->setY(canview->getY());}
if (number == 4) {pointda->setX(canview->getXUnMod());pointda->setY(canview->getY());/*calculate(); labeldubbelverhoudingb->setNum(double(dubbelverhouding));*/}
if (number > 4) { number = 0; labeldubbelverhoudingb->setText("");crosspoint->hide();rechtea->hide(); rechteb->hide(); rechtec->hide(), rechted->hide();pointaa->hide();pointba->hide();  pointca->hide(); pointda->hide();pointab->hide();pointbb->hide();  pointcb->hide(); pointdb->hide(); number++;pointaa->setX(canview->getXUnMod());  pointaa->setY(canview->getY()); pointaa->show();}

can->setAllChanged();
can->update();
}

void bWidgetb::drawlineanimation()
{
if (number == 1)
{
rechtea->show();
if (calculaterico(pointaa->x(), pointaa->y(),canview->getmovingX(),canview->getmovingY()) < 0) 
{rechtea->setPoints(givemecrosspointx(0, 0, 10, 0, pointaa->x(),pointaa->y() ,canview->getmovingX() , canview->getmovingY()) , 0,0, givemecrosspointy(0, 0, 0, 10, pointaa->x(),pointaa->y() ,canview->getmovingX() , canview->getmovingY()));
}
if (calculaterico(pointaa->x(), pointaa->y(),canview->getmovingX(),canview->getmovingY()) > 0) 
{rechtea->setPoints(0,(givemecrosspointy(0, 0, 0, 10, pointaa->x(), pointaa->y() ,canview->getmovingX() , canview->getmovingY())), givemecrosspointx(0, 900, 10, 900, pointaa->x(),pointaa->y() ,canview->getmovingX() , canview->getmovingY()) , 900);
}
 if(canview->getmovingX()-int(pointaa->x())==0 )
 {
 rechtea->setPoints(int(pointaa->x()), 0, int(pointaa->x()), 900);
 }
 if(canview->getmovingY()-int(pointaa->y())==0 )
 {
 rechtea->setPoints(0, int(pointaa->y()),1100, int(pointaa->y()));
}

//cout <<" xaa coordinaat " <<<<" y coordinaat: "<<rechtea->y()<<endl;
pointab->setX(canview->getmovingX());
pointab->setY(canview->getmovingY());
pointab->show();
can->setAllChanged();
can->update();
//rechta->setPen(QPen(QColor(90,100,120), 5, PenStyle(DotLine)));
}

if (number == 2)
{
rechteb->show();
if (calculaterico(pointba->x(), pointba->y(),canview->getmovingX(),canview->getmovingY()) < 0) 
{rechteb->setPoints(givemecrosspointx(0, 0, 10, 0, pointba->x(),pointba->y() ,canview->getmovingX() , canview->getmovingY()) , 0,0, givemecrosspointy(0, 0, 0, 10, pointba->x(),pointba->y() ,canview->getmovingX() , canview->getmovingY()));
}
if (calculaterico(pointba->x(), pointba->y(),canview->getmovingX(),canview->getmovingY()) > 0) 
{rechteb->setPoints(0,(givemecrosspointy(0, 0, 0, 10, pointba->x(), pointba->y() ,canview->getmovingX() , canview->getmovingY())), givemecrosspointx(0, 900, 10, 900, pointba->x(),pointba->y() ,canview->getmovingX() , canview->getmovingY()) , 900);
}
 if(canview->getmovingX()-int(pointba->x())==0 )
 {
 rechteb->setPoints(int(pointba->x()), 0, int(pointba->x()), 900);
 }
 if(canview->getmovingY()-int(pointba->y())==0 )
 {
 rechteb->setPoints(0, int(pointba->y()),1100, int(pointba->y()));
}
// rechteb->setPoints(int(pointba->x()), int(pointba->y()),canview->getmovingX(),canview->getmovingY());
pointbb->setX(canview->getmovingX());
pointbb->setY(canview->getmovingY());
pointbb->show();
calculatecrosspoint();
crosspoint->setX(crosspointx);
crosspoint->setY(crosspointy);
crosspoint->show();
can->setAllChanged();
can->update();
}

if (number == 3)
{
rechtec->show();
if (calculaterico(crosspointx,crosspointy,canview->getmovingX(),canview->getmovingY()) < 0) 
{rechtec->setPoints(givemecrosspointx(0, 0, 10, 0, crosspointx, crosspointy,canview->getmovingX() , canview->getmovingY()) , 0,0, givemecrosspointy(0, 0, 0, 10, crosspointx, crosspointy ,canview->getmovingX() , canview->getmovingY()));
}
if (calculaterico(crosspointx,crosspointy,canview->getmovingX(),canview->getmovingY()) > 0) 
{rechtec->setPoints(0,(givemecrosspointy(0, 0, 0, 10,crosspointx, crosspointy ,canview->getmovingX() , canview->getmovingY())), givemecrosspointx(0, 900, 10, 900, crosspointx, crosspointy,canview->getmovingX() , canview->getmovingY()) , 900);
}
 if(canview->getmovingX()-crosspointx==0 )
 {
 rechtec->setPoints(crosspointx, 0, crosspointx, 900);
 }
 if(canview->getmovingY()-crosspointy==0 )
 {
 rechtec->setPoints(0, crosspointy,1100, crosspointy);
}

//rechtec->setPoints(crosspointx, crosspointy,canview->getmovingX(),canview->getmovingY());
pointcb->setX(canview->getmovingX());
pointcb->setY(canview->getmovingY());
pointcb->show();
can->setAllChanged();
can->update();
}

if (number == 4)
{
rechted->show();
if (calculaterico(crosspointx,crosspointy,canview->getmovingX(),canview->getmovingY()) < 0) 
{rechted->setPoints(givemecrosspointx(0, 0, 10, 0, crosspointx, crosspointy,canview->getmovingX() , canview->getmovingY()) , 0,0, givemecrosspointy(0, 0, 0, 10, crosspointx, crosspointy ,canview->getmovingX() , canview->getmovingY()));
}
if (calculaterico(crosspointx,crosspointy,canview->getmovingX(),canview->getmovingY()) > 0) 
{rechted->setPoints(0,(givemecrosspointy(0, 0, 0, 10,crosspointx, crosspointy ,canview->getmovingX() , canview->getmovingY())), givemecrosspointx(0, 900, 10, 900, crosspointx, crosspointy,canview->getmovingX() , canview->getmovingY()) , 900);
}
 if(canview->getmovingX()-crosspointx==0 )
 {
 rechted->setPoints(crosspointx, 0, crosspointx, 900);
 }
 if(canview->getmovingY()-crosspointy==0 )
 {
 rechted->setPoints(0, crosspointy,1100, crosspointy);
}
/*rechted->show();
rechted->setPoints(crosspointx,  crosspointy,canview->getmovingX(),canview->getmovingY());*/
pointdb->setX(canview->getmovingX());
pointdb->setY(canview->getmovingY());
pointdb->show();
can->setAllChanged();
can->update();
calculate(); labeldubbelverhoudingb->setNum(double(dubbelverhouding));
}

}

void bWidgetb::drawlineafteranimation()
{
if(number==1)
{
//rechtea->setPen(QPen(QColor(90,100,120), 5, PenStyle(DotLine)));
//cout<<"lijn 1 is getekend"<<endl;
}
}

void bWidgetb::drawscale(int lengte)
{
for(int i=0;i<1280;i=i+50)
{
QString string;
string.setNum(i);
line = new QCanvasLine(can);
line->setPoints(i, 240+(lengte/2),i,240-(lengte/2));
label = new QCanvasText(string, can);
label->setX(i);
label->setY(240+lengte);
line->show();
label->show();
}
}

void bWidgetb::makepoints()
{
pointaa = new QCanvasEllipse(8,8,0,360*16, can);
pointaa->setBrush(QBrush(red,SolidPattern ));
pointaa->setPen(QPen(green,8,PenStyle(NoPen)));
pointaa->setZ(2);

pointab = new QCanvasEllipse(8,8,0,360*16, can);
pointab->setBrush(QBrush(red,SolidPattern ));
pointab->setPen(QPen(green,8,PenStyle(NoPen)));
pointab->setZ(2);

pointba = new QCanvasEllipse(8,8,0,360*16, can);
pointba->setBrush(QBrush(red,SolidPattern ));
pointba->setPen(QPen(green,8,PenStyle(NoPen)));
pointba->setZ(2);

pointbb = new QCanvasEllipse(8,8,0,360*16, can);
pointbb->setBrush(QBrush(red,SolidPattern ));
pointbb->setPen(QPen(green,8,PenStyle(NoPen)));
pointbb->setZ(2);

pointca = new QCanvasEllipse(8,8,0,360*16, can);
pointca->setBrush(QBrush(red,SolidPattern ));
pointca->setPen(QPen(green,8,PenStyle(NoPen)));
pointca->setZ(2);

pointcb = new QCanvasEllipse(8,8,0,360*16, can);
pointcb->setBrush(QBrush(red,SolidPattern ));
pointcb->setPen(QPen(green,8,PenStyle(NoPen)));
pointcb->setZ(2);

pointda = new QCanvasEllipse(8,8,0,360*16, can);
pointda->setBrush(QBrush(red,SolidPattern ));
pointda->setPen(QPen(green,8,PenStyle(NoPen)));
pointda->setZ(2);

pointdb = new QCanvasEllipse(8,8,0,360*16, can);
pointdb->setBrush(QBrush(red,SolidPattern ));
pointdb->setPen(QPen(green,8,PenStyle(NoPen)));
pointdb->setZ(2);

crosspoint = new QCanvasEllipse(12,12,0,360*16, can);
crosspoint->setBrush(QBrush(green,SolidPattern ));
crosspoint->setPen(QPen(green,5,PenStyle(NoPen)));
crosspoint->setZ(2);

}
void bWidgetb::makecanvas()
{
	can = new QCanvas(this,"can");
    	can->resize(1100,900);
     	canview = new DisplayCanvasView(can,this,"canview");
	QColor BackgroundColor(200,220,225);
	can->setBackgroundColor(BackgroundColor);
	connect (canview, SIGNAL(ClickValueChanged()), this, SLOT(doupdate()));
	connect(canview, SIGNAL(MouseReleased()), this, SLOT(drawlineafteranimation()));
	connect (canview, SIGNAL(MouseMoves()), this, SLOT(drawlineanimation()));
	//drawscale(20);
}


void  bWidgetb::makelines()
{
rechtea = new QCanvasLine(can);
rechtea->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));

rechteb = new QCanvasLine(can);
rechteb->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));

rechtec = new QCanvasLine(can);
rechtec->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));

rechted = new QCanvasLine(can);
rechted->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));

//rechtee = new QCanvasLine(can);
//rechtee->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));
//rechtee->setPoints(-200,200,300,200);
//rechtee->setZ(10);
//rechtee->show();
}


// void bWidgetb::makebuttons()
// {
// 	quit = new QPushButton( "&Afsluiten", this, "quit" );
//     	quit->setFont( QFont( "Nimbius Sans", 10, QFont::Bold) );
// 	quit->setFixedWidth(170);
// 	connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
// }

void bWidgetb::makegrid()
{
	grid = new QGridLayout( this, 2, 2, 10, -1, "grid");
	canvas = new QVBoxLayout;
	info = new QVBoxLayout;
	bovenaan = new QHBoxLayout;
// 	onderaan = new QHBoxLayout;
}

void bWidgetb::addlayouts()
{
	//grid->addMultiCellLayout(onderaan,2, 2, 1,2);
	//addChildLayout(canvas);
	//bovenaan->addChildLayout(info);
	//addLayout((addChildLayout(info)),1,1);
	grid->addLayout(info, 1 , 1);
	grid->addLayout(canvas, 1,2);
	grid->setColStretch( 2, 10 );
	
//	bovenaan->addLayout( info, 1, 1 );
}

void bWidgetb::makelabels()
{
 labeldubbelverhoudinga = new QLabel (tr("Dubblerate"), this, "label",0);
 labeldubbelverhoudingb = new QLabel ("", this, "label",0);
//	labelinfo = new QLabel ("Welkom,\n\nIn de kader hiernaast zie je\niemands woonkamer.\nWanneer je op 'next' klikt\n zal je zien wat er gebeurt\nmet een lichtstraal die\nvanuit de lamp vertrekt...", this, "labelinfo",0);
}

void bWidgetb::maketekstinfo()
{
//mimesource = new QMimeSourceFactory();
//mimesource->setExtensionType("html", "text/html;charset=iso8859-1");
tekstinfo = new QTextBrowser(this, "tekstinfo");
tekstinfo->setFixedWidth(170);
tekstinfo->setFixedHeight(280);
tekstinfo->setText(tr("Welcome,\n\nPress on the surface to draw a line.\nA line is made by 2 points. When you click, you mark a first point. Hold the mouse down and you can mark a second point when releasing the mouse.When you have drawn 4 lines, the dubbelverhouding will be calculated."));
//tekstinfo->setSource("./storyhowto.html");
}

void bWidgetb::allesingrid()
{
	canvas->addWidget( canview );
    	info->addWidget( tekstinfo);
	info->addWidget(  labeldubbelverhoudinga);
	info->addWidget(  labeldubbelverhoudingb);
	info->addStretch(1);
	//info->addWidget(nextbutton);
	//info->addWidget(quit);
// 	onderaan->addStretch( 1 );
// 	onderaan->addWidget(quit);
}
