#ifndef BWIDGETB_H
#define  BWIDGETB_H

#include <qwidget.h>
#include <qpushbutton.h>
#include <qfont.h>
#include <qlayout.h>
#include <qcanvas.h>
#include <qcolor.h> 
#include <qlabel.h> 
#include <qtabbar.h> 
#include <qtabwidget.h> 
#include <qtextbrowser.h> 
#include "displaycanvasview.h"

class bWidgetb: public QWidget
{
	Q_OBJECT
public:
	bWidgetb( QWidget *parent, const char *name);
	~bWidgetb();
	
	int number, crosspointx, crosspointy, crosspointz, drawrico;
	double long dubbelverhouding;
	void setstandardsa(); //zet standaard values
	/*void makebuttons();*/ //buttons worden er aangemaakt en geconnect!
	void makegrid(); // maak grid aan en maak de layouts aan.
	void addlayouts(); // voeg layouts toe aan de grid gemaakt in makegrid.
	void makelabels(); // maak labels
	void allesingrid(); // plaats alles in de grid
	void makecanvas(); //maakt canvas en canview en zet kleur en dergelijke
	void  makepoints();
	void updatecanvas(); //teken lijnen en dergelijk
	void maketekstinfo();
	void makelines(); //maak de lijnen
	void drawscale(int lengte);
	void calculate();
	void calculatecrosspoint();
	double calculaterico(double xaa, double yaa, double xab, double yab);
	int givemecrosspointx(double xaa, double yaa, double xab, double yab, double xba, double yba, double xbb, double ybb);
	int givemecrosspointy(double xaa, double yaa, double xab, double yab, double xba, double yba, double xbb, double ybb);
	double givemeu(double xa, double ya, double xb, double yb);
	double givemev(double xa, double ya, double xb, double yb);
			
	QGridLayout *grid;
	QGridLayout *gridinframeleft;
	
	QVBoxLayout *info;
    	QVBoxLayout *canvas;
	QHBoxLayout *bovenaan;
	//QHBoxLayout *onderaan;
	
	QCanvas *can;
    	DisplayCanvasView *canview;
//     	QPushButton *quit;
	
	QTextBrowser *tekstinfo;
	
	QCanvasEllipse *pointaa;
	QCanvasEllipse *pointab;
	QCanvasEllipse *pointba;
	QCanvasEllipse *pointbb;
	QCanvasEllipse *pointca;
	QCanvasEllipse *pointcb;
	QCanvasEllipse *pointda;
	QCanvasEllipse *pointdb;
	QCanvasEllipse *crosspoint;
	
	QLabel *labeldubbelverhoudinga;
	QLabel *labeldubbelverhoudingb;
	
	QCanvasLine *line;
	QCanvasLine *rechtea;
	QCanvasLine *rechteb;
	QCanvasLine *rechtec;
	QCanvasLine *rechted;
	//QCanvasLine *rechtee;
	QCanvasText *label;

protected:
QMouseEvent  *mouseevent;
	
public slots:
	void doupdate();
	void drawlineanimation();
	void drawlineafteranimation();
//	void tostart();
};

#endif // BWIDGETB_H
