/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "cwidgeta.h"
#include <stdio.h>
#include <iostream>

using namespace std;

cWidgeta::cWidgeta( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
	// "Nimbius Sans"
	this->setFont(QFont( "Bitstream Vera Sans", 12, QFont::Normal));
	setstandards();
	makecanvas();
	//makelinestyles(); --> werkt nog niet
	//makemessageboxes();
	makebuttons();
	makegrid();
	addlayouts();
	makelabels();
	maketekstinfo();
	allesingrid();	  
	
 	updatecanvas();
	
}

cWidgeta::~cWidgeta()
{}

void cWidgeta::setstandards()
{
number = 0;
movedown=0;
containera = 0;
}

void cWidgeta::tostart()
{
number=5;
updatecanvas();
}

void cWidgeta::next()
{	
	number++;
	cout << "next!" <<"number = "<<number<< endl;
	updatecanvas();
}

void cWidgeta::updatecanvas()
{	
	if (number==5){number=0; removeall();tekstinfo->setText(tr("Welcome,\n\nHere you see a sea-landscape. We are going to study archimedes. We are about to see what happens to a ship when its gains more weigth. Therefore we need a ship and a harbour, press 'Next' to draw these things"));nextbutton->show();}
	if (number == 1) {tekstinfo->setText(tr("Now there is a ship and a harbour. In this simulation the ship itself has no weight. It lays completely above the water. But you can put a container in the ship by dragging it with your mouse.")); qcanvasspritecontainer->move(300,310,0); qcanvasspriteharbour->show();  qcanvasspriteship->show(); qcanvasspritecontainer->show(); nextbutton->hide();}
	if (number == 2) {tekstinfo->setText(tr("You have seen now that the ship went deeper into the water after putting the container on it.\nLet's do the same thing with another ship. Press 'Next' to go on."));nextbutton->show(); } 
	if (number == 3) {qcanvasspritecontainer->move(300,310,0); qcanvasspriteharbour->show();  qcanvasspriteship->hide(); qcanvasspritecontainer->show(); qcanvasspriterowboat->show(); containera = 0;movedown = 0; tekstinfo->setText(tr("A small rowboat has entered the harbour. What will happen if we put a heavy container on the rowboat?"));nextbutton->hide();}  
	if (number == 4) {tekstinfo->setText(tr("The rowboat, which was a lot smaller than the previous ship, is sunken after putting the same container on it.\nThen, what makes a boat float?? The weight, the size, or both?\nIf you want to see the animation again, press 'Next' or 'To start'"));nextbutton->show();}
// 	if (number == 5) {tekstinfo->setText("De lichtstraal ging door het water heen. Maar ze veranderde wel weer van richting, ze werd 'gebroken'.\n\nJe hebt nu gezien wat er allemaal met een lichtbundel kan gebeuren. Als je de animatie opnieuw wil zien moet je weer op 'next' klikken. Wil je nog meer experimenteren met lichtstralen kan je naar de 2e tab gaan.");}
	
	//can->setAllChanged();
	can->update();
}

void cWidgeta::makecanvas()
{
	QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
	QString boot,sea_landscape,harbour,container,roeiboot;
	boot.append(appBaseDir);
	sea_landscape.append(appBaseDir);
	harbour.append(appBaseDir);
	container.append(appBaseDir);
	roeiboot.append(appBaseDir);
	boot.append("pictures/boot2.png");
	sea_landscape.append("pictures/sea_landscape4.jpg");
	harbour.append("pictures/harbour2.png");
	container.append("pictures/container1.png");
	roeiboot.append("pictures/roeiboot.png");
	
	can = new QCanvas(this,"can");
    	can->resize(1100,900);
     	canview = new DisplayCanvasView(can,this,"canview");
	connect (canview, SIGNAL(MouseMoves()), this, SLOT(doupdate()));
	QPixmap jan(sea_landscape, "JPEG", 0); //backgrounds
	can->setBackgroundPixmap(jan);
	
	pixarrayship = new QCanvasPixmapArray(boot,0);  
	qcanvasspriteship = new QCanvasSprite(pixarrayship, can);
	qcanvasspriteship->move(450,260,0);
	//qcanvasspritelamp->rotate(20);
	qcanvasspriteship->setZ(10);
	//qcanvassprite->setFrame(1);
// 	qcanvasspriteship->show();
	
	pixarrayharbour = new QCanvasPixmapArray(harbour,1);  
	qcanvasspriteharbour = new QCanvasSprite(pixarrayharbour, can);
	qcanvasspriteharbour->move(0,0,0);
	qcanvasspriteharbour->setZ(9);
	
	pixarraycontainer = new QCanvasPixmapArray(container,1);  
	qcanvasspritecontainer = new QCanvasSprite(pixarraycontainer, can);
	qcanvasspritecontainer->move(300,310,0);
	qcanvasspritecontainer->setZ(19);
	
	pixarrayrowboat = new QCanvasPixmapArray(roeiboot,1);  
	qcanvasspriterowboat = new QCanvasSprite(pixarrayrowboat, can);
	qcanvasspriterowboat->move(450,305,0);
	qcanvasspriterowboat->setZ(9);
}

void cWidgeta::doupdate()
{
if (number == 1)
{
if (containera != 1) // is 1 als hij er al op staat
{
qcanvasspritecontainer->move(canview->getmovingX()-45,canview->getmovingY()-9,0);
if (qcanvasspritecontainer->x() < 660 && qcanvasspritecontainer->x()>380 && qcanvasspritecontainer->y()>262 && qcanvasspritecontainer->y()<287)
{
containera = 1;
if ( containera == 1) movedown++;
if ( movedown == 1)  
{
qcanvasspritecontainer->setX(480);qcanvasspritecontainer->setY(270);
for (int i =  int(qcanvasspriteship->y()); i<300;i++) { usleep(25000); qcanvasspriteship->move(450,i,0); qcanvasspritecontainer->moveBy(0,1); can->update(); }
}
number++; updatecanvas();
//if (movedown == 2) qcanvasspriteship->move(450,290,0) ;
}
else {containera = 0; }
}
if (containera == 1)  {qcanvasspritecontainer->move(480,310,0) ;}
can->setAllChanged();
can->update();
}
// 2e boot

if (number == 3)
//cout << "JA"<<endl;
{
if (containera != 1) // is 1 als hij er al op staat
{
qcanvasspritecontainer->move(canview->getmovingX()-45,canview->getmovingY()-9,0);
if (qcanvasspritecontainer->x() < 620 && qcanvasspritecontainer->x()>360 && qcanvasspritecontainer->y()>272 && qcanvasspritecontainer->y()<300)
{
containera = 1;
if ( containera == 1) movedown++;
if ( movedown == 1)  
{
qcanvasspritecontainer->setX(460);qcanvasspritecontainer->setY(296);
for (int i =  int(qcanvasspriterowboat->y()); i<470;i++) { usleep(25000); qcanvasspriterowboat->move(450,i,0); qcanvasspritecontainer->moveBy(0,1); can->update(); }
}
number++; updatecanvas();
//if (movedown == 2) qcanvasspriteship->move(450,290,0) ;
}
else {containera = 0; }
}
if (containera == 1)  {qcanvasspritecontainer->move(460,461,0) ;}
can->setAllChanged();
can->update();
}

}

void cWidgeta::removeall()
{
containera = 0;movedown = 0; 
qcanvasspritecontainer->hide();
qcanvasspriteship->hide();
qcanvasspriteharbour->hide();
qcanvasspriterowboat->hide();
qcanvasspriterowboat->move(450,305,0);
qcanvasspritecontainer->move(300,310,0);
qcanvasspriteharbour->move(0,0,0);
qcanvasspriteship->move(450,260,0);
can->update();
}


void cWidgeta::makebuttons()
{
	//quit = new QPushButton( "&Afsluiten", this, "quit" );
    	//quit->setFont( QFont( "Nimbius Sans", 10, QFont::Bold) );
	//quit->setFixedWidth(170);
	nextbutton = new QPushButton( tr("&Next"), this, "nextbutton" );
   	nextbutton->setFont( QFont("Nimbius Sans", 10, QFont::Bold) );
	nextbutton->setFixedWidth(170);
	//nextbutton->setState(QButton::Off);
	tostartbutton = new QPushButton( tr("To &Start"), this, "tostartbutton" );
   	tostartbutton->setFont( QFont("Nimbius Sans", 10, QFont::Bold) );
	tostartbutton->setFixedWidth(170);
	/*connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );*/
	connect( nextbutton, SIGNAL(clicked()), this , SLOT(next()) );
	connect( tostartbutton, SIGNAL(clicked()), this , SLOT(tostart()) );
}

void cWidgeta::makegrid()
{
	grid = new QGridLayout( this, 2, 2, 10, -1, "grid");
	canvas = new QVBoxLayout;
	info = new QVBoxLayout;
	//bovenaan = new QHBoxLayout;
	onderaan = new QHBoxLayout;
}

void cWidgeta::addlayouts()
{
	grid->addMultiCellLayout(onderaan,2, 2, 1,2);
	//addChildLayout(canvas);
	//bovenaan->addChildLayout(info);
	//addLayout((addChildLayout(info)),1,1);
	grid->addLayout(info, 1 , 1);
	grid->addLayout(canvas, 1,2);
	grid->setColStretch( 2, 10 );
	
//	bovenaan->addLayout( info, 1, 1 );
}

void cWidgeta::makelabels()
{
//	labelinfo = new QLabel ("Welkom,\n\nIn de kader hiernaast zie je\niemands woonkamer.\nWanneer je op 'next' klikt\n zal je zien wat er gebeurt\nmet een lichtstraal die\nvanuit de lamp vertrekt...", this, "labelinfo",0);
}

void cWidgeta::maketekstinfo()
{
//mimesource = new QMimeSourceFactory();
//mimesource->setExtensionType("html", "text/html;charset=iso8859-1");
tekstinfo = new QTextBrowser(this, "tekstinfo");
tekstinfo->setFixedWidth(170);
tekstinfo->setText(tr("Welcome,\n\nHere you see a sea-landscape. We are going to study archimedes. We are about to see what happens to a ship when its gains more weigth. Therefore we need a ship and a harbour, press 'Next' to draw these things."));
//tekstinfo->setSource("./storyhowto.html");
}

void cWidgeta::allesingrid()
{
	canvas->addWidget( canview );
    	info->addWidget( tekstinfo);
	//info->addWidget(nextbutton);
	//info->addWidget(quit);
	onderaan->addStretch( 1 );
	onderaan->addWidget(tostartbutton);
	onderaan->addWidget(nextbutton);
	//onderaan->addWidget(quit);
}
