/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CWIDGETA_H
#define  CWIDGETA_H

#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlcdnumber.h>
#include <qfont.h>
#include <qlayout.h>

#include <qcanvas.h>

#include <qcolor.h> 

#include <qlabel.h> 
#include <math.h>
#include <qlineedit.h> 
#include <qmessagebox.h> 
#include <qpixmap.h>
#include <qtabbar.h> 
#include <qtabwidget.h> 
#include <qtextbrowser.h> 
#include "displaycanvasview.h"
//mogen eigelijk weg:
//#include <qspinbox.h> 
//#include <qslider.h> 
#include <kglobal.h>
#include <klocale.h>
#include <kstandarddirs.h>
#include <kcmdlineargs.h>

class cWidgeta: public QWidget
{
	Q_OBJECT
public:
	cWidgeta( QWidget *parent, const char *name);	
	~cWidgeta();
	
	int number; // hoe vaak al next gedrukt?
	int movedown; // hoe diep al aan het zinken?
	int containera;
	void setstandards(); //zet standaard values
	void makemessageboxes(); //info boxes worden er aangemaak
	void makebuttons(); //buttons worden er aangemaakt en geconnect!
	void makegrid(); // maak grid aan en maak de layouts aan.
	void addlayouts(); // voeg layouts toe aan de grid gemaakt in makegrid.
	void makelabels(); // maak labels
	void allesingrid(); // plaats alles in de grid
	void makecanvas(); //maakt canvas en canview en zet kleur en dergelijke
	void updatecanvas(); //teken lijnen en dergelijk
	void maketekstinfo();
	//void drawlines(QCanvasLine *lijn, int xa, int ya, int xb, int yb);
	void removeall(); //wil je de tutorial opnieuw doen dan moeten eerst alle lijnen gedelete worden. coordinaten op 00 zetten fzo? anders setvisible(false)
		
	QGridLayout *grid;
	
	QVBoxLayout *info;
    	QVBoxLayout *canvas;
	//QHBoxLayout *bovenaan;
	QHBoxLayout *onderaan;
	
	QCanvas *can;
    	DisplayCanvasView *canview;
    	//QPushButton *quit;
	QPushButton *nextbutton;
	QPushButton *tostartbutton;
	

	QLabel *labelinfo;	
	
	QMimeSourceFactory *mimesource;
	QTextBrowser *tekstinfo;
	
	//messageboxen
	QMessageBox *qmessageboxalpha;
	QMessageBox *qmessageboxn;
	QMessageBox *qmessageboxinf; //inf van oneindig;als lichtstraal naar +INF gaat kan comp ze niet tekenen
	QPixmap *qpixmapwarning;  // in messageboxen
	

	//NEW FEATURES
	//fish
	
	/*QCanvasPixmap *qcanvasfishb;
	QCanvasSprite *qcanvassprite;
	QCanvasPixmapArray *pixarray;
	
	//tabs
	QTabBar *tabbar;
	*/
	QCanvasPixmapArray *pixarrayship;
	QCanvasSprite *qcanvasspriteship;
	QCanvasPixmapArray *pixarrayharbour;
	QCanvasSprite *qcanvasspriteharbour;
	QCanvasPixmapArray *pixarraycontainer;
	QCanvasSprite *qcanvasspritecontainer;
	QCanvasPixmapArray *pixarrayrowboat;
	QCanvasSprite *qcanvasspriterowboat;
	
public slots:
	void next();
	void tostart();
	void doupdate();
};
#endif // CWIDGETA_H
