/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "cwidgetb.h"
#include <stdio.h>
#include <iostream>
using namespace std;

cWidgetb::cWidgetb( QWidget *parent, const char *name )
    : QWidget( parent, name )
{
  this->setFont(QFont( "Bitstream Vera Sans", 11, QFont::Normal));
  makecanvas();
  makeobjects();
  maketeksten();
  makebuttons();
  makeframes();
  makeframecontent();
  setstandardvalues();
  makegrids();
  makelayoutboxes();
  addlayouts();
  allesingrid();
  doupdate();
  }

cWidgetb::~cWidgetb()
{}

void cWidgetb::doupdate()
{
calculate();
tekstschip->setY(100+int(down));
boat->setY(50+int(down));
can->update();
QString stringmassab;
stringmassab.setNum(int((lineeditbodem->text()).toDouble()*(lineedithoogte->text()).toDouble()*((lineeditdichtheida->text()).toDouble())));
stringmassab.append (" kg");
//QString stringmassa;
//stringmassa.append("Mass ship: ");
//stringmassa.append(stringmassab);
labelmassaa->setText("Mass ship: ");
labelmassab->setText(stringmassab);

if (fs < fv)
{
QString stringdiepteb,stringdieptec;
stringdiepteb.setNum(diepte);
stringdiepteb.append (" m");
labeldiepteb->setText(stringdiepteb);
stringdieptec.setNum((down/150)*100);
stringdieptec.append (" %");
labeldieptec->setText(stringdieptec);
}
if (fs == fv)
{
labeldieptea->setText(tr("The boat floats."));
labeldiepteb->setText(tr("The boat is wholly\nonder the water,\nbut doesn't sink."));
labeldieptec->setText("");
}
if (fs > fv)
{
labeldieptea->setText(tr("The boat is sunken."));
labeldiepteb->setText(tr("The boat is\non the bottom."));
labeldieptec->setText("");
}


}

void cWidgetb::calculate()
{
fs = (lineeditbodem->text()).toDouble()*(lineedithoogte->text()).toDouble()*(lineeditdichtheida->text()).toDouble()*(981/100);
fv = (lineeditbodem->text()).toDouble()*(lineedithoogte->text()).toDouble()*(lineeditdichtheidb->text()).toDouble()*(981/100);
cout << fs<<endl;
cout << fv<<endl;
if (fs>fv) {cout << "hij zinkt"<<endl; boat->hide(); tekstschip->hide(); seab->setPoints(300,200,1280,200);}
if (fs<fv) { cout << "hij zinkt niet"<<endl; calculatedown();boat->show(); tekstschip->show();seab->setPoints(450,200,1280,200);}
if (fs == fv) {cout << "hij zweeft"<<endl;down = 200;boat->show(); tekstschip->show();seab->setPoints(300,200,1280,200);}
}

void cWidgetb::calculatedown()
{
double gewicht, vloeistofvoorgewicht;
gewicht = ((lineeditdichtheida->text()).toDouble()*(lineeditbodem->text()).toDouble()*(lineedithoogte->text()).toDouble());
vloeistofvoorgewicht = ((gewicht)/ ( (lineeditdichtheidb->text()).toDouble()));
diepte = vloeistofvoorgewicht / (lineeditbodem->text()).toDouble();
down  = (150/(lineedithoogte->text()).toDouble())*diepte;
cout << diepte <<endl;
}

void cWidgetb::makecanvas()
{
  can = new QCanvas(this,"can");
  can->resize(1100,900);
  canview = new QCanvasView(can,this,"canview");
  QColor BackgroundColor(200,220,225);
  can->setBackgroundColor(BackgroundColor);
}

void cWidgetb::makeobjects()
{
boat = new QCanvasRectangle(300,50,150,150,can);
boat->show();
seaa = new QCanvasLine(can);
seaa->setPoints(0,200,300,200);
seaa->show();
seab = new QCanvasLine(can);
seab->setPoints(450,200,1280,200);
seab->show();

boat->setBrush(QBrush(QColor(90,100,120),BDiagPattern ));
boat->setPen(QPen(QColor(90,100,120),5,PenStyle(SolidLine)));
  
seaa->setPen(QPen(QColor(90,100,120), 5, PenStyle(DashDotLine)));
seab->setPen(QPen(QColor(90,100,120), 5, PenStyle(DashDotLine)));
}

void cWidgetb::maketeksten()
{
  tekstschip = new QCanvasText(tr("Ship"), can);
  tekstvloeistof = new QCanvasText(tr("Liquid"), can);
  tekstgas = new QCanvasText(tr("Gas"), can);
  tekstschip->setX(350);
  tekstschip->setY(100+int(down));
  tekstvloeistof->setX(50);
  tekstvloeistof->setY(220);
  tekstgas->setX(50);
  tekstgas->setY(160);
  tekstschip->show();
  tekstvloeistof->show();
  tekstgas->show();
}

void cWidgetb::maketekstinfo()
{
tekstinfo = new QTextBrowser(this, "tekstinfo");
tekstinfo->setFixedWidth(170);
tekstinfo->setFixedHeight(115);
tekstinfo->setText(tr("Welcome,\n\nYou can change the values of the parameters. After pressing 'Update', the drawing well be updated."));
}

void cWidgetb::makebuttons()
{
  updatebutton = new QPushButton( tr("&Update"), this, "updatebutton" );
  updatebutton->setFont( QFont( "Nimbius Sans", 10, QFont::Bold ) );
  updatebutton->setFixedWidth(170);
  connect( updatebutton, SIGNAL(clicked()), this , SLOT(doupdate()) );
}

void cWidgetb::makeframes()
{
    frameleft = new QFrame( this, "frame3" );
    frameleft->setFixedWidth(175);//frameleft
    frameleft->setFrameShape( QFrame::StyledPanel );
    frameleft->setFrameShadow( QFrame::Raised );    
 }

 void cWidgetb::makeframecontent()
 {	
 	  maketekstinfo();
 	  labeldichtheida = new QLabel(tr("Density ship\n(kg/m)"), frameleft,"roa",0);
	  labeldichtheidb = new QLabel(tr("Density Liquid\n(kg/m)"), frameleft,"rob",0);
	  labelbodem = new QLabel (tr("Area bottom\nship (m)"), frameleft,"opp",0);
	  labelhoogte  = new QLabel(tr("Height ship (m)"), frameleft,"hoog",0);
	  labelmassaa = new QLabel(tr("Mass ship:"), frameleft,"masa",0);
	  labelmassab = new QLabel("", frameleft,"masb",0);
	  
	  labeldieptea = new QLabel(tr("Ship under liquid:"), frameleft,"diep",0);
	  labeldiepteb = new QLabel("", frameleft,"diep",0);
	  labeldieptec = new QLabel("", frameleft,"diep",0);
	  
	  lineeditdichtheida = new QLineEdit(frameleft, "roa")  ;
	  lineeditdichtheidb  = new QLineEdit(frameleft, "rob");
	  lineeditbodem = new QLineEdit(frameleft, "opp") ;
	  lineedithoogte = new QLineEdit(frameleft, "hoog") ;
  }
void cWidgetb::makegrids()
{
  grid = new QGridLayout( this, 3, 5, 10, -1, "grid");
  gridinframeleft = new QGridLayout( frameleft, 1, 1, 10, -1, "gridframeleft");
}

void cWidgetb::makelayoutboxes()
{
	a = new QVBoxLayout;
        b = new QVBoxLayout;
    	onderaan = new QHBoxLayout;
	layoutframeleft = new QVBoxLayout;
}

void cWidgetb::addlayouts()
{	
	grid->addMultiCellLayout(onderaan, 2,2,0,4);
	grid->addLayout(a,1,0);
	grid->addMultiCellLayout(b,1,1,1,4);
	grid->setColStretch( 0, 0 );
	grid->setColStretch( 1, 0 );
	grid->setColStretch( 2, 0 );
	grid->setColStretch( 3, 0 );
	grid->setColStretch( 4, 10 );
	
	gridinframeleft->addLayout(layoutframeleft,0,0); 
}

void cWidgetb::allesinframeleft()
{
layoutframeleft->addWidget(labeldichtheida);
layoutframeleft->addWidget(lineeditdichtheida);
layoutframeleft->addStretch( 1 );
layoutframeleft->addWidget(labeldichtheidb);
layoutframeleft->addWidget(lineeditdichtheidb);
layoutframeleft->addStretch( 1 );
layoutframeleft->addWidget(labelbodem);
layoutframeleft->addWidget(lineeditbodem);
layoutframeleft->addStretch( 1 );
layoutframeleft->addWidget(labelhoogte);
layoutframeleft->addWidget(lineedithoogte);
layoutframeleft->addStretch( 1 );
layoutframeleft->addWidget(labelmassaa);
layoutframeleft->addWidget(labelmassab);
layoutframeleft->addStretch( 1 );
layoutframeleft->addWidget(labeldieptea);
layoutframeleft->addWidget(labeldiepteb);
layoutframeleft->addWidget(labeldieptec);
layoutframeleft->addStretch( 10 );
}

void cWidgetb::allesingrid()
{
allesinframeleft();
onderaan->addStretch(1);
onderaan->addWidget(updatebutton);
//a->setSpacing(0);
a->addWidget(tekstinfo);
//a->addStretch(1);
a->addWidget(frameleft);
b->addWidget(canview);  
}

void cWidgetb::setstandardvalues()
{
	  QString stringdichtheida, stringdichtheidb,stringhoogte , stringbodem, stringmassa;
	  stringdichtheida.setNum(400);
	  stringdichtheidb.setNum(1025);
	  stringbodem.setNum(100);
	  stringhoogte.setNum(150);
	  down = 0;
 	  lineeditdichtheida->setText(stringdichtheida);
	  lineeditdichtheidb->setText(stringdichtheidb);
	  lineeditbodem->setText(stringbodem);
	  lineedithoogte->setText(stringhoogte);
}
