/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ACIDGETB_H
#define  CWIDGETB_H

#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlcdnumber.h>
#include <qfont.h>
#include <qlayout.h>

#include <qradiobutton.h> 
#include <qbuttongroup.h> 

#include "lcdrange.h"
#include <qcanvas.h> 

#include <qcolor.h> 
#include <qpainter.h>
#include <qlabel.h> 
#include <math.h>
#include <qlineedit.h> 
#include <qmessagebox.h> 
#include <qpixmap.h>
#include <qspinbox.h> 
#include <qframe.h> 
#include <qtextbrowser.h> 

//mogen eigelijk weg:
//#include <qspinbox.h> 
//#include <qslider.h> 
#include <kglobal.h>
#include <klocale.h>
#include <kstandarddirs.h>
#include <kcmdlineargs.h>

class cWidgetb: public QWidget
{
	Q_OBJECT
public:
	cWidgetb( QWidget *parent, const char *name);	
	~cWidgetb();
private:	
	double down,diepte; //hoe dien al gezonken
	QString stringdichtheida, stringdichtheidb, stringbodem,stringhoogte, stringmassa;
	double fs, fv ; //newtons	
	void setstandardvalues(); //standaard waarden/ start waarden worden er gezet
	void makebuttons(); //buttons worden er aangemaakt en geconnect!
	void makegrids(); // maak grid aan en maak de layouts aan.
	void addlayouts(); // voeg layouts toe aan de grid gemaakt in makegrid.
	void makelayoutboxes();
	void makelabels(); // maak labels
	void allesingrid(); // plaats alles in de grid
	void allesinframeleft(); //plaats alles in de frame waar de lcds en sliders zitten
	void makeframecontent();
	void makecanvas(); //maakt canvas en canview en zet kleur en dergelijke
	void makeframes(); //maak de frames zoals frameleft
	void makeobjects();
	void maketeksten();
	void calculate();
	void calculatedown();
	void maketekstinfo();
	
	QGridLayout *grid;
	QGridLayout *gridinframeleft;
	QVBoxLayout *layoutframeleft;
	QVBoxLayout *a; 
    	QVBoxLayout *b; 
	QHBoxLayout *onderaan; //onderaan met knoppen
	QCanvas *can;
    	QCanvasView *canview;
    	
	QPushButton *updatebutton;
	
	QFrame *frameleft;
	
	QCanvasRectangle *boat;
	QCanvasLine *seaa;
	QCanvasLine *seab;
	
	  QCanvasText *tekstschip;
  	  QCanvasText *tekstvloeistof;
  	  QCanvasText *tekstgas;
	  
	  QLabel *labeldichtheida;
	  QLabel *labeldichtheidb;
	  QLabel *labelbodem;
	  QLabel *labelhoogte;
	  QLabel *labelmassaa;
	  QLabel *labelmassab;
	  QLabel *labeldieptea;
	  QLabel *labeldiepteb;
	  QLabel *labeldieptec;
	  
	 QLineEdit   *lineeditdichtheida;
	  QLineEdit  *lineeditdichtheidb;
	 QLineEdit   *lineeditbodem;
	  QLineEdit   *lineedithoogte;
	  
	  QTextBrowser *tekstinfo;
	  
public slots:
	void doupdate();
	
};
#endif // CWIDGETB_H
