/***************************************************************************
 *   Copyright (C) 2005 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DWIDGETA_H
#define  DWIDGETA_H

#include <qapplication.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <qlcdnumber.h>
#include <qfont.h>
#include <qlayout.h>

#include <qcanvas.h>
#include <qtimer.h>
#include <qcolor.h> 

#include <qlabel.h> 
#include <math.h>
#include <qlineedit.h> 
#include <qmessagebox.h> 
#include <qpixmap.h>
#include <qtabbar.h> 
#include <qtabwidget.h> 
#include <qtextbrowser.h> 
//mogen eigelijk weg:
//#include <qspinbox.h> 
//#include <qslider.h> 
#include <kglobal.h>
#include <klocale.h>
#include <kstandarddirs.h>
#include <kcmdlineargs.h>

class dWidgeta: public QWidget
{
	Q_OBJECT
public:
	dWidgeta( QWidget *parent, const char *name);	
	~dWidgeta();
	
	int number; // hoe vaak al next gedrukt?
	int movement; // vlieger, trein of manneke bewegen
	int counter; //hoe vaak al bewogen?
	//int movedown; // hoe diep al aan het zinken?
	//int containera;
	void setstandards(); //zet standaard values
	void makebuttons(); //buttons worden er aangemaakt en geconnect!
	void makegrid(); // maak grid aan en maak de layouts aan.
	void addlayouts(); // voeg layouts toe aan de grid gemaakt in makegrid.
	void allesingrid(); // plaats alles in de grid
	void makecanvas(); //maakt canvas en canview en zet kleur en dergelijke
	void updatecanvas(); //teken lijnen en dergelijk
	void maketekstinfo();
	void drawroutes(int speed);
	void makeobjects();
	void removeall(); //wil je de tutorial opnieuw doen dan moeten eerst alle lijnen gedelete worden. coordinaten op 00 zetten fzo? anders setvisible(false)
	void animation();
		
	QGridLayout *grid;
	
	QVBoxLayout *info;
    	QVBoxLayout *canvas;
	QHBoxLayout *onderaan;
	
	QCanvas *can;
    	QCanvasView *canview;
    	QPushButton *nextbutton;
	QPushButton *tostartbutton;
	

	QLabel *labelinfo;	
	QMimeSourceFactory *mimesource;
	QTextBrowser *tekstinfo;
	
	QCanvasPixmapArray *pixarrayairplane;
	
	QCanvasSprite *qcanvasspriteairplane;
	
	QCanvasPixmapArray *pixarraytrain;
	QCanvasSprite *qcanvasspritetrain;
	QCanvasPixmapArray *pixarrayman;
	QCanvasSprite *qcanvasspriteman1;QCanvasSprite *qcanvasspriteman2;QCanvasSprite *qcanvasspriteman3;
	
private:	
	QCanvasLine *routeaa;
	QCanvasLine *routeab;
	QCanvasLine *routeac;
	QCanvasLine *routead;
	QCanvasLine *routeba;
	QCanvasLine *routebb;
	QCanvasLine *routebc;
	QCanvasLine *routeca;
	
	QCanvasEllipse *youarehere;
	QCanvasText *tekstyouarehere;
	QCanvasText *thewinneris;
	
	QTimer *routetimer; //to draw possible routes
	QTimer *realtimer; //to draw animation
	QTimer *stoptimer; //to stop both above timers
	
public slots:
	void next();
	void tostart();
	void doupdate();
	void whattodowhenanimation();
	void stopthetimer();
	void drawingroutes();
};
#endif // DWIDGETA_H
