/***************************************************************************
 *   Copyright (C) 2004 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "dwidgetb.h"
#include <stdio.h>
#include <iostream>
using namespace std;

dWidgetb::dWidgetb( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
	// "Nimbius Sans"
	this->setFont(QFont( "Bitstream Vera Sans", 10, QFont::Normal));
	maketekstinfo();
	makecanvas();
	makeframes();
	makeframecontent();
	makelines();
	makecanvastext();
	makeellipses();
	setstandardsa();
	makebuttons();
	makegrid();
	addlayouts();
	allesingrid();	  
	
	QColor pen(255,230,65);
  	QPen solidline(pen, 25);
	solidline.setStyle (SolidLine);
}

dWidgetb::~dWidgetb()
{}

void dWidgetb::setstandardsa()
{
sliderlinea->setRange(0,200);
sliderlineb->setRange(100,300);
sliderlinec->setRange(200,400);
sliderlined->setRange(300,1100);
sliderlineperson->setRange(0,1100);
sliderlinehotel->setRange(0,1100);

sliderlinea->setValue(100);
sliderlineb->setValue(200);
sliderlinec->setValue(300);
sliderlined->setValue(400);

sliderlineperson->setValue(200);
sliderlinehotel->setValue(400);
a = int(sliderlineperson->value());
b = int(sliderlineperson->value());

ellipsperson->move(sliderlineperson->value(),sliderlinea->value());
ellipshotel->move(sliderlinehotel->value(),sliderlined->value());

spinboxzee->setValue(5);
spinboxkust->setValue(10);
spinboxdijk->setValue(15);

showall();
doupdate();
connectsliders();
connectspinboxes();
}

void dWidgetb::showall()
{
rechtea->show();rechteb->show();rechtec->show();rechted->show();routea->show();routeb->show();routec->show();
textlinea->show();textlineb->show();textlinec->show();textlined->show();textzee->show();textdijk->show();textkust->show();
recdijk->show();reczee->show();reckust->show();
ellipsperson->show();ellipshotel->show();
}

void dWidgetb::doupdate()
{
calculateroute();
rechtea->setPoints(0,sliderlinea->value(),1100,sliderlinea->value());
rechteb->setPoints(0,sliderlineb->value(),1100,sliderlineb->value());
rechtec->setPoints(0,sliderlinec->value(),1100,sliderlinec->value());
rechted->setPoints(0,sliderlined->value(),1100,sliderlined->value());

routea->setPoints(sliderlineperson->value(),sliderlinea->value(),a,sliderlineb->value());
routeb->setPoints(a,sliderlineb->value(),b,sliderlinec->value());
routec->setPoints(b,sliderlinec->value(),sliderlinehotel->value(),sliderlined->value());

textlinea->setY(sliderlinea->value()-20);
textlineb->setY(sliderlineb->value()-20);
textlinec->setY(sliderlinec->value()-20);
textlined->setY(sliderlined->value()-20);
textdijk->setY((textlinec->y()+textlined->y())/2); /**zelfde resultaat via textline en sliders*/
textzee->setY((sliderlinea->value()+sliderlineb->value())/2-20);
textkust->setY((sliderlineb->value()+sliderlinec->value())/2-20);

recdijk->setSize(1100,sliderlined->value()-sliderlinec->value());
recdijk->setX(0);recdijk->setY(sliderlinec->value());
reckust->setSize(1100,sliderlinec->value()-sliderlineb->value());
reckust->setX(0);reckust->setY(sliderlineb->value());
reczee->setSize(1100,sliderlineb->value()-sliderlinea->value());
reczee->setX(0);reczee->setY(sliderlinea->value());

showall();
if (sliderlinea->value()==sliderlineb->value()) {textzee->hide();textlinea->hide();}
if (sliderlineb->value()==sliderlinec->value()) {textkust->hide();textlinec->hide();}
if (sliderlinec->value()==sliderlined->value()) {textdijk->hide();textlined->hide();}

can->setAllChanged();
can->update();
}

void dWidgetb::update(int value)
{
if (spinboxzee->value()==0) {spinboxzee->setValue(1);}
if (spinboxkust->value()==0) {spinboxkust->setValue(1);}
if (spinboxdijk->value()==0) {spinboxdijk->setValue(1);}
doupdate();
}

void dWidgetb::calculateroute()
{
if (sliderlineperson->value() <sliderlinehotel->value())
	{
	previousroutetime=999999; //grootste theoretische waarde is 5000
	for(int i = sliderlineperson->value(); i<sliderlinehotel->value();i++)
	{
		for (int j = i; j<sliderlinehotel->value();j++)
		{
		if (routetime(i,j) < previousroutetime) {previousroutetime = routetime(i,j);a=i; b=j;}
		}
	}
	}
if (sliderlineperson->value() == sliderlinehotel->value()) {a = sliderlineperson->value(); b = sliderlineperson->value();}
if (sliderlineperson->value() > sliderlinehotel->value())
{
{
	previousroutetime=999999; //grootste theoretische waarde is 5000
	for(int i = sliderlineperson->value(); i>sliderlinehotel->value();i--)
	{
		for (int j = i; j>sliderlinehotel->value();j--)
		{
		if (routetime(i,j) < previousroutetime) {previousroutetime = routetime(i,j);a=i; b=j;}
		}
	}
	}
}
/**STEL DAT ER HELEMAAL GEEN DIJK IS*/
if (sliderlined->value() == sliderlinec->value()) 
{
b = sliderlinehotel->value();
if (sliderlineperson->value() <sliderlinehotel->value())
	{
	previousroutetime=999999; //grootste theoretische waarde is 5000
	for(int i = sliderlineperson->value(); i<sliderlinehotel->value();i++)
	{
		if (routetime(i,b) < previousroutetime) {previousroutetime = routetime(i,b);a=i;}
	}
	}
if (sliderlineperson->value() == sliderlinehotel->value()) {a = sliderlineperson->value(); b = sliderlineperson->value();}
if (sliderlineperson->value() > sliderlinehotel->value())
{
{
	previousroutetime=999999; //grootste theoretische waarde is 5000
	for(int i = sliderlineperson->value(); i>sliderlinehotel->value();i--)
	{
		if (routetime(i,b) < previousroutetime) {previousroutetime = routetime(i,b);a=i;}
	}
	}
}
}
/**STEL DAT ER HELEMAAL GEEN ZEE IS*/
if (sliderlinea->value() == sliderlineb->value()) 
{
a = sliderlineperson->value();
if (sliderlineperson->value() <sliderlinehotel->value())
	{
	previousroutetime=999999; //grootste theoretische waarde is 5000
	for(int i = sliderlineperson->value(); i<sliderlinehotel->value();i++)
	{
		if (routetime(a,i) < previousroutetime) {previousroutetime = routetime(a,i);b=i;}
	}
	}
if (sliderlineperson->value() == sliderlinehotel->value()) {a = sliderlineperson->value(); b = sliderlineperson->value();}
if (sliderlineperson->value() > sliderlinehotel->value())
{
{
	previousroutetime=999999; //grootste theoretische waarde is 5000
	for(int i = sliderlineperson->value(); i>sliderlinehotel->value();i--)
	{
		if (routetime(a,i) < previousroutetime) {previousroutetime = routetime(a,i);b=i;}
	}
	}
}
/**STEL DAT ER HELEMAAL GEEN STRAND IS=> NEEDS IMPLEMENTATION!!!!!*/
}
if (sliderlineb->value() == sliderlinec->value()) 
{
if (sliderlineperson->value() <sliderlinehotel->value())
	{
	previousroutetime=999999; //grootste theoretische waarde is 5000
	for(int i = sliderlineperson->value(); i<sliderlinehotel->value();i++)
	{
		if (routetime(i,i) < previousroutetime) {previousroutetime = routetime(i,i);b=i;a=i;}
	}
	}
if (sliderlineperson->value() == sliderlinehotel->value()) {a = sliderlineperson->value(); b = sliderlineperson->value();}
if (sliderlineperson->value() > sliderlinehotel->value())
{
{
	previousroutetime=999999; //grootste theoretische waarde is 5000
	for(int i = sliderlineperson->value(); i>sliderlinehotel->value();i--)
	{
		if (routetime(i,i) < previousroutetime) {previousroutetime = routetime(i,i);b=i;a=i;}
	}
	}
}
}
}

double dWidgetb::routetime(int i, int j)
{
double time = ((sqrt(((double(i)-sliderlineperson->value())*(double(i)-sliderlineperson->value()))+((sliderlineb->value()-sliderlinea->value())*(sliderlineb->value()-sliderlinea->value()))   ))/spinboxzee->value()) + 
((sqrt(((double(j)-double(i))*(double(j)-double(i)))+((sliderlinec->value()-sliderlineb->value())*(sliderlinec->value()-sliderlineb->value()))))/spinboxkust->value()) +
((sqrt(((sliderlinehotel->value()-double(j))*(sliderlinehotel->value()-double(j)))+((sliderlined->value()-sliderlinec->value())*(sliderlined->value()-sliderlinec->value()))))/spinboxdijk->value()) ;
return time;
}

void dWidgetb::sliderachanged(int value)
{
ellipsperson->move(sliderlineperson->value(),sliderlinea->value());
sliderlinea->setRange(0,sliderlineb->value());
QString content, number;
content = tr("Y-coordinate a: ");
number.setNum(value);
content.append(number);
labellinea->setText(content);
doupdate();
}

void dWidgetb::sliderbchanged(int value)
{
if (sliderlinea->value()>sliderlineb->value()) {sliderlinea->setValue(sliderlineb->value());}
sliderlineb->setRange(sliderlinea->value(),sliderlinec->value());
QString content, number;
content = tr("Y-coordinate b: ");
number.setNum(value);
content.append(number);
labellineb->setText(content);
doupdate();
}

void dWidgetb::slidercchanged(int value)
{
if (sliderlineb->value()>sliderlinec->value()) {sliderlineb->setValue(sliderlinec->value());}
sliderlinec->setRange(sliderlineb->value(),sliderlined->value());
QString content, number;
content = tr("Y-coordinate c: ");
number.setNum(value);
content.append(number);
labellinec->setText(content);
doupdate();
}

void dWidgetb::sliderdchanged(int value)
{
ellipshotel->move(sliderlinehotel->value(),sliderlined->value());
if (sliderlinec->value()>sliderlined->value()) {sliderlinec->setValue(sliderlined->value());}
sliderlined->setRange(sliderlinec->value(),1000);
QString content, number;
content = tr("Y-coordinate d: ");
number.setNum(value);
content.append(number);
labellined->setText(content);
doupdate();
}

void dWidgetb::sliderpersonchanged(int value)
{
ellipsperson->move(sliderlineperson->value(),sliderlinea->value());
QString content, number;
content = tr("X-coordinate P: ");
number.setNum(value);
content.append(number);
labelperson->setText(content);
doupdate();
}

void dWidgetb::sliderhotelchanged(int value)
{
ellipshotel->move(sliderlinehotel->value(),sliderlined->value());
QString content, number;
content = tr("X-coordinate H: ");
number.setNum(value);
content.append(number);
labelhotel->setText(content);
doupdate();
}

void dWidgetb::makecanvas()
{
	can = new QCanvas(this,"can");//number++;
    	can->resize(1100,900);
     	canview = new QCanvasView(can,this,"canview");
	QColor BackgroundColor(200,220,225);
	can->setBackgroundColor(BackgroundColor);
	
}

void  dWidgetb::makelines()
{
rechtea = new QCanvasLine(can);
rechtea->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));

rechteb = new QCanvasLine(can);
rechteb->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));

rechtec = new QCanvasLine(can);
rechtec->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));

rechted = new QCanvasLine(can);
rechted->setPen(QPen(QColor(90,100,120), 5, PenStyle(SolidLine)));

routea = new QCanvasLine(can);
routea->setPen(QPen(red, 5, PenStyle(SolidLine)));
routea->setZ(30);

routeb = new QCanvasLine(can);
routeb->setPen(QPen(red, 5, PenStyle(SolidLine)));
routeb->setZ(30);

routec = new QCanvasLine(can);
routec->setPen(QPen(red, 5, PenStyle(SolidLine)));
routec->setZ(30);

reczee = new QCanvasRectangle ( can );
reczee->setBrush(QBrush(QColor(90,100,120),BDiagPattern ));
reczee->setPen(QPen(green,5,PenStyle(NoPen)));

reckust = new QCanvasRectangle ( can );
reckust->setBrush(QBrush(QColor(90,100,120),DiagCrossPattern ));
reckust->setPen(QPen(green,5,PenStyle(NoPen)));

recdijk = new QCanvasRectangle ( can );
recdijk->setBrush(QBrush(QColor(90,100,120),FDiagPattern ));
recdijk->setPen(QPen(green,5,PenStyle(NoPen)));
}

void dWidgetb::makecanvastext()
{
textlinea = new QCanvasText(tr("Line a"), can);
textlinea->setX(20);
textlineb = new QCanvasText(tr("Line b"), can);
textlineb->setX(20);
textlinec = new QCanvasText(tr("Line c"), can);
textlinec->setX(20);
textlined = new QCanvasText(tr("Line d"), can);
textlined->setX(20);

textkust = new QCanvasText(tr("Coast"), can);
textkust->setX(80);
textdijk = new QCanvasText(tr("Dike"), can);
textdijk->setX(80);
textzee = new QCanvasText(tr("Sea"), can);
textzee->setX(80);
}

void dWidgetb::makeellipses()
{
ellipsperson = new QCanvasEllipse(20, 20, can);
ellipsperson->setBrush(QBrush(red,SolidPattern ));
ellipsperson->setPen(QPen(green,5,PenStyle(NoPen)));
ellipshotel = new QCanvasEllipse(20, 20, can);
ellipshotel->setBrush(QBrush(red,SolidPattern ));
ellipshotel->setPen(QPen(green,5,PenStyle(NoPen)));

}

 void dWidgetb::makeframecontent()
 {
 makelabels();
 makesliders();
 makespinboxes();
  }

void dWidgetb::makelabels()
{
 	  labellinea = new QLabel(tr("Y-coordinate a: 20"), frameleft,"roa",0);
	  labellineb = new QLabel(tr("Y-coordinate b: 120"), frameleft,"rob",0);
	  labellinec = new QLabel(tr("Y-coordinate c: 220"), frameleft,"roc",0);
	  labellined = new QLabel(tr("Y-coordinate d: 320"), frameleft,"rod",0);
	  labelspeed = new QLabel(tr("Speed at: "), frameleft,"roe",0);
	  labelzee = new QLabel(tr("Sea "), frameleft,"roe",0);
	  labeldijk = new QLabel(tr("Dike"), frameleft,"roe",0);
	  labelkust = new QLabel(tr("Beach"), frameleft,"roe",0);
	  labelperson = new QLabel(tr("X-coordinate P: 200"), frameleft,"roe",0);
	  labelhotel = new QLabel(tr("X-coordinate H: 400"), frameleft,"roe",0);
	  
}
  
void dWidgetb::makesliders()
{
	  sliderlinea = new QSlider(Qt::Horizontal, frameleft);
	  sliderlineb = new QSlider(Qt::Horizontal, frameleft);
	  sliderlinec = new QSlider(Qt::Horizontal, frameleft);
	  sliderlined = new QSlider(Qt::Horizontal, frameleft);
	  sliderlineperson = new QSlider(Qt::Horizontal, frameleft);
	  sliderlinehotel = new QSlider(Qt::Horizontal, frameleft);
}

void dWidgetb::makespinboxes()
{
spinboxzee = new QSpinBox (0,99,1,frameleft);
spinboxzee->setFixedWidth(40);
spinboxdijk = new QSpinBox (0,99,1,frameleft);
spinboxdijk->setFixedWidth(40);
spinboxkust = new QSpinBox (0,99,1,frameleft);
spinboxkust->setFixedWidth(40);
}

void dWidgetb::connectsliders()
{
	connect(sliderlinea, SIGNAL(valueChanged(int)), this , SLOT(sliderachanged(int)) );
	connect(sliderlineb, SIGNAL(valueChanged(int)), this , SLOT(sliderbchanged(int)) );
	connect(sliderlinec, SIGNAL(valueChanged(int)), this , SLOT(slidercchanged(int)) );
	connect(sliderlined, SIGNAL(valueChanged(int)), this , SLOT(sliderdchanged(int)) );
	connect(sliderlineperson, SIGNAL(valueChanged(int)), this , SLOT(sliderpersonchanged(int)) );
	connect(sliderlinehotel, SIGNAL(valueChanged(int)), this , SLOT(sliderhotelchanged(int)) );
}

void dWidgetb::connectspinboxes()
{
connect(spinboxzee, SIGNAL(valueChanged(int)), this , SLOT(update(int)));
connect(spinboxkust, SIGNAL(valueChanged(int)), this , SLOT(update(int)));
connect(spinboxdijk, SIGNAL(valueChanged(int)), this , SLOT(update(int)));
}  

void dWidgetb::makeframes()
{
    frameleft = new QFrame( this, "frame" );
    frameleft->setFixedWidth(175);//frameleft
    //frameleft->setFixedHeight(maximumSize().height());
    frameleft->setFrameShape( QFrame::StyledPanel );
    frameleft->setFrameShadow( QFrame::Raised );    
 }
 
 void dWidgetb::makebuttons()
{
  updatebutton = new QPushButton( tr("&Update"), this, "updatebutton" );
  updatebutton->setFont( QFont( "Nimbius Sans", 10, QFont::Bold ) );
  updatebutton->setFixedWidth(170);
  connect( updatebutton, SIGNAL(clicked()), this , SLOT(doupdate()) );
}

void dWidgetb::makegrid()
{
	grid = new QGridLayout( this, 2, 2, 10, -1, "grid");
	gridinframeleft = new QGridLayout( frameleft, 1, 1, 10, -1, "gridframeleft");
	canvas = new QVBoxLayout;
	info = new QVBoxLayout;
	onderaan = new QHBoxLayout;
	layoutframeleft = new QVBoxLayout;
	sublayoutframelefta = new QHBoxLayout;
	sublayoutframeleftb = new QHBoxLayout;
}

void dWidgetb::addlayouts()
{
	grid->addLayout(info, 0 , 0);
//	grid->addLayout(frameleft, 2,1);
	grid->addLayout(canvas, 0,1);
	onderaan->addStretch(1);
	grid->addMultiCellLayout(onderaan, 1,1,0,1);
	grid->setColStretch( 1, 10 );
	gridinframeleft->addLayout(layoutframeleft,0,0); 
}

void dWidgetb::allesinframeleft()
{
layoutframeleft->setSpacing(0);
layoutframeleft->addWidget(labellinea);
layoutframeleft->addWidget(sliderlinea);
//layoutframeleft->addStretch( 1 );
layoutframeleft->addWidget(labellineb);
layoutframeleft->addWidget(sliderlineb);
//layoutframeleft->addStretch( 1 );
layoutframeleft->addWidget(labellinec);
layoutframeleft->addWidget(sliderlinec);
//layoutframeleft->addStretch( 1 );
layoutframeleft->addWidget(labellined);
layoutframeleft->addWidget(sliderlined);
//layoutframeleft->addStretch( 10 );
layoutframeleft->addSpacing(20);
layoutframeleft->addWidget(labelspeed);
layoutframeleft->addLayout(sublayoutframelefta);
sublayoutframelefta->addWidget(labelzee);
sublayoutframelefta->addStretch( 1 );
sublayoutframelefta->addWidget(labelkust);
sublayoutframelefta->addStretch( 1 );
sublayoutframelefta->addWidget(labeldijk);
layoutframeleft->addLayout(sublayoutframeleftb);
sublayoutframeleftb->addWidget(spinboxzee);
sublayoutframeleftb->addStretch( 1 );
sublayoutframeleftb->addWidget(spinboxkust);
sublayoutframeleftb->addStretch( 1 );
sublayoutframeleftb->addWidget(spinboxdijk);
layoutframeleft->addSpacing(20);
layoutframeleft->addWidget(labelperson);
layoutframeleft->addWidget(sliderlineperson);
layoutframeleft->addWidget(labelhotel);
layoutframeleft->addWidget(sliderlinehotel);
layoutframeleft->addStretch( 10 );
//layoutframeleft->setSpacing(0);
//layoutframeleft->addWidget(sliderlined);

}

void dWidgetb::maketekstinfo()
{
//mimesource = new QMimeSourceFactory();
//mimesource->setExtensionType("html", "text/html;charset=iso8859-1");
tekstinfo = new QTextBrowser(this, "tekstinfo");
tekstinfo->setFixedWidth(175);
tekstinfo->setFixedHeight(200);
tekstinfo->setText(tr("Welcome,\n\nA person (P) is swimming in the sea and wants to go to his hotel (H) as fast as possible. This person won't go equally fast everywhere.\nWhich way should he take?\nbtw: All parameters are changeable."));
//tekstinfo->setSource("./storyhowto.html");
}

void dWidgetb::allesingrid()
{	allesinframeleft();
	canvas->addWidget( canview );
    	info->addWidget( tekstinfo);
	info->addWidget(frameleft);
	//info->addStretch(10);
	onderaan->addWidget(updatebutton);
}
