#ifndef DWIDGETB_H
#define  DWIDGETB_H

#include <qspinbox.h> 
#include <qwidget.h>
#include <qpushbutton.h>
#include <qfont.h>
#include <qlayout.h>
#include <qcanvas.h>
#include <qcolor.h> 
#include <qlabel.h> 
#include <qtextbrowser.h> 
#include <qslider.h> 
#include <math.h>
class dWidgetb: public QWidget
{
	Q_OBJECT
public:	

	dWidgetb( QWidget *parent, const char *name);
	~dWidgetb();
protected:	
	int a,b;
	double previousroutetime;
	double routetime(int i, int j);
	void setstandardsa(); //zet standaard values
	void makeframes();	
	void showall();
	void makeframecontent();
	void makelabels();
	void makesliders();
	void makespinboxes();
	void connectsliders();
	void connectspinboxes();
	void allesinframeleft();
	void makegrid(); // maak grid aan en maak de layouts aan.
	void addlayouts(); // voeg layouts toe aan de grid gemaakt in makegrid.
	void allesingrid(); // plaats alles in de grid
	void makecanvas(); //maakt canvas en canview en zet kleur en dergelijke
	void makebuttons();
	void updatecanvas(); //teken lijnen en dergelijk
	void maketekstinfo();
	void makelines(); //maak de lijnen
	void makecanvastext(); //make the canvastexts
	void makeellipses();
	void calculateroute();
	
	QGridLayout *grid;
	QGridLayout *gridinframeleft;
	QVBoxLayout *layoutframeleft;
	QVBoxLayout *info;
    	QVBoxLayout *canvas;
	QHBoxLayout *onderaan;
	
	QFrame *frameleft;
	
	QHBoxLayout *sublayoutframelefta;
	QHBoxLayout *sublayoutframeleftb;	
	QButton *updatebutton;
	
	QCanvas *can;
    	QCanvasView *canview;
	
	QTextBrowser *tekstinfo;
	private:
	QSpinBox *spinboxzee;
	QSpinBox *spinboxdijk;
	QSpinBox *spinboxkust;
	
	QCanvasRectangle *reczee;
	QCanvasRectangle *recdijk;
	QCanvasRectangle *reckust;
		
	QCanvasLine *rechtea;
	QCanvasLine *rechteb;
	QCanvasLine *rechtec;
	QCanvasLine *rechted;
	QCanvasLine *routea;
	QCanvasLine *routeb;
	QCanvasLine *routec;
	
	QSlider *sliderlinea;
	QSlider *sliderlineb;
	QSlider *sliderlinec;
	QSlider *sliderlined;
	QSlider *sliderlineperson;
	QSlider *sliderlinehotel;	
	
	QLabel *labellinea;
	QLabel *labellineb;
	QLabel *labellinec;
	QLabel *labellined;
	QLabel *labelspeed;
	QLabel *labelzee;
	QLabel *labeldijk;
	QLabel *labelkust;
	QLabel *labelperson;
	QLabel *labelhotel;
	
	QCanvasText *textlinea;
	QCanvasText *textlineb;
	QCanvasText *textlinec;
	QCanvasText *textlined;
	QCanvasText *textkust;
	QCanvasText *textdijk;
	QCanvasText *textzee;

	QCanvasEllipse *ellipsperson;
	QCanvasEllipse *ellipshotel;
public slots:
	void doupdate();
	void update(int value);
	void sliderachanged(int value);
	void sliderbchanged(int value);
	void slidercchanged(int value);
	void sliderdchanged(int value);
	void sliderpersonchanged(int value);
	void sliderhotelchanged(int value);
//	void tostart();
};


#endif // DWIDGETB_H

