/***************************************************************************
 *   Copyright (C) 2005 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "exercices.h"
#include <stdio.h>
#include <iostream>
using namespace std;

Exercices::Exercices(QWidget *parent, const char *name, QString path, int numberofexer)
 : QWidget(parent, name)
{	
// nl_BE = nl_NL => nl 
	QString locale_small;
	locale_small=QTextCodec::locale();
	locale_small.setLength(2);
	//locale_small="ru";
// end
// not nl ru fr en => en
int a = 0;
if (locale_small == "ru") a =1;
if (locale_small == "nl") a =1;
if (locale_small == "fr") a =1;
if (locale_small == "gl") a =1;
/** Jos, uncomment the following line to use spanish translations*/
//if (locale_small == "es") a =1; 
if (locale_small == "en") a =1;
if (a != 1) locale_small="en";
//end

	pathplace = path;
	pathplace.append(locale_small);
	pathplace.append(".html");
	exercicenumber =numberofexer;
	setstandards();
	this->setFont(QFont( "Nimbius Sans", 12, QFont::Normal));
	makebuttons();
	makegrid();
	addlayouts();
	maketekstinfo(locale_small);
	allesingrid();	  
}


Exercices::~Exercices()
{
}


 void Exercices::setstandards()
 {
number = 1;
 }
 
 void Exercices::next()
 {
int numberofexer = exercicenumber;
numberofexer++;
QString oefening[numberofexer];
for (int i=1;i<numberofexer;i++)
{
QString jos;
jos = jos.setNum( i );  
oefening[i] = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
oefening[i].append("html_pages/exercice");
oefening[i].append(jos);
oefening[i].append( pathplace);
//cout<<"jaja, tis allemaal iets "<<oefening[i]<<endl;
}

number++;
if(number > exercicenumber){number = 1;}
if (number <= numberofexer) { tekstinforight->setSource( oefening[number]);}
//cout << number << "is de number"<<endl;
 }
 
  void Exercices::previos()
 {
 //cout <<"exercicenumber: "<<exercicenumber<<endl;
int numberofexer = exercicenumber;
numberofexer++;
QString oefening[numberofexer];
for (int i=1;i<numberofexer;i++)
{
QString jos,path;
// path="_archimedes";
// path.append(QTextCodec::locale());
// path.append(".html");
jos = jos.setNum( i );
oefening[i] = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
oefening[i].append("html_pages/exercice");
oefening[i].append(jos);
oefening[i].append(pathplace);
//cout<<"jaja, tis allemaal iets "<<oefening[i]<<endl;
}
number--;
if(number <= 0) {number = 1;}
if (number > 0) { tekstinforight->setSource( oefening[number]);}
//cout << number << "is de number"<<endl;
 }
 
void Exercices::makebuttons()
{
	//quit = new QPushButton( "&Afsluiten", this, "quit" );
    	//quit->setFont( QFont( "Nimbius Sans", 10, QFont::Bold )  );
	//quit->setFixedWidth(170);	
	//connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );
		
	volgendebutton = new QPushButton( tr("&Next"), this, "volgendebut");
    	volgendebutton ->setFont( QFont( "Nimbius Sans", 10, QFont::Bold )  );
	volgendebutton ->setFixedWidth(170);	
	connect( volgendebutton, SIGNAL(clicked()), this, SLOT(next()) );
		
	//int a = 1;	if (a== 1) { cout <<"'t werkt"<<endl;}
	
	vorigebutton = new QPushButton(tr( "&Previous"), this, "vorigebut");
    	vorigebutton ->setFont( QFont( "Nimbius Sans", 10, QFont::Bold )  );
	vorigebutton ->setFixedWidth(170);	
	connect( vorigebutton, SIGNAL(clicked()), this, SLOT(previos()) );
}

void Exercices::makegrid()
{
	grid = new QGridLayout( this, 2, 2, 10, -1, "grid");
	layoutonder = new QHBoxLayout;
	oefeningen = new QVBoxLayout;
	info = new QVBoxLayout;
}

void Exercices::addlayouts()
{
	grid->addLayout( oefeningen, 0, 1 );
	grid->addLayout( info, 0, 0 );
	grid->addMultiCellLayout(layoutonder, 1,1,0,1);
	grid->setColStretch( 1, 10 );
}

void Exercices::maketekstinfo(QString locale_small)
{
tekstinfoleft = new QTextBrowser(this, "tekstinfoleft");
tekstinfoleft->setFixedWidth(170);
tekstinfoleft->setText(tr("Welcome,\n\nIn the frame on the right of this frame, you can solve exercices. After solving one you can press 'solutions' to see the right answer.\nPress 'next' to view the next exercice."));
tekstinforight = new QTextBrowser(this, "tekstinforight");

//FOR RUSSIAN TRANSLATION: UNCOMMENT THIS
if (locale_small== "ru")
{
tempsource = new  QMimeSourceFactory ();
tempsource->setExtensionType("html", "text/html;charset=iso8859-5");
tekstinforight->setMimeSourceFactory(tempsource);
}


QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";

QString home;
home.append(appBaseDir);
home.append("html_pages/exercice1");
home.append(pathplace);
tekstinforight->setSource( home);
//cout<<"home:"<<  home<<endl;
}

void Exercices::allesingrid()
{
	oefeningen->addWidget( tekstinforight);
	layoutonder->addStretch(1);
	layoutonder->addWidget(vorigebutton);
	layoutonder->addWidget(volgendebutton);
	//layoutonder->addWidget(quit);
	info->addWidget( tekstinfoleft);
}
 

