/***************************************************************************
 *   Copyright (C) 2005 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "shell.h"
#include <stdio.h>
#include <iostream>
using namespace std;

Shell::Shell( QWidget *parent, const char *name, WFlags f)
    : QMainWindow(parent, name, f)
{
previouswidget = 0;
makemenustructure();
makestartpage();
}

Shell::~Shell()
{
}

void Shell::about()
{
aboutdialog = new Aboutdialog(NULL, "aboutbox" , FALSE, NULL );
aboutdialog->show();
}

void Shell::makemenustructure()
{
help = new QPopupMenu( this );
bestand = new QPopupMenu( this );
nieuw = new QPopupMenu( this );

menuBar()->insertItem( tr("&File"), bestand );
bestand->insertItem( tr("&New"), nieuw );
menuBar()->insertItem(tr( "&Help"), help );

help->insertItem( tr("&About"), this, SLOT(about()));
bestand->insertItem(tr( "&Close"),this, SLOT(setstartpage()) );
bestand->insertItem(tr( "&Quit"), qApp, SLOT(quit()) );
nieuw->insertItem( tr("Educative project &Optics"), this, SLOT(setoptica()) ); 
nieuw->insertItem( tr("Educative project &Dubblerates"), this, SLOT(setdeelverhouding()) ); 
nieuw->insertItem( tr("Educative project &Archimedes"), this, SLOT(setarchimedes()) ); 
nieuw->insertItem( tr("Educative project &Extreme_functoin_values"), this, SLOT(setextremaprobs()) ); 
}

void Shell::makestartpage()
{
startpage = new StartPage(this,"startpage_eindwerk");
startpage->setMinimumWidth(860);
startpage->setMinimumHeight(670);
startpage->setMaximumWidth(1280);
startpage->setMaximumHeight(1024);
startpage->resize(945,675);
this->setCentralWidget(startpage);
startpage->show();
}

void Shell::setoptica()
{
if (previouswidget != 1)
{
if (previouswidget == 0) startpage->hide();
if (previouswidget == 2) bmainwindow->hide();
if (previouswidget == 3) cmainwindow->hide();
if (previouswidget == 4) dmainwindow->hide();
amainwindow = new Mainwindowa(this,"amainwindow_eindwerk");
amainwindow->setMinimumWidth(860);
amainwindow->setMinimumHeight(600);
amainwindow->setMaximumWidth(1280);
amainwindow->setMaximumHeight(1024);
amainwindow->resize(1020,600);
this->setCentralWidget(amainwindow);
amainwindow->show();
removeoldwidgets();
previouswidget = 1;
}
}

void Shell::setdeelverhouding()
{
if (previouswidget != 2)
{
if (previouswidget == 0) startpage->hide();
if (previouswidget == 1) amainwindow->hide();
if (previouswidget == 3) cmainwindow->hide();
if (previouswidget == 4) dmainwindow->hide();
bmainwindow = new Mainwindowb(this,"bmainwindow_eindwerk");
bmainwindow->setMinimumWidth(860);
bmainwindow->setMinimumHeight(600);
bmainwindow->setMaximumWidth(1280);
bmainwindow->setMaximumHeight(1024);
bmainwindow->resize(1020,600);
this->setCentralWidget(bmainwindow);
bmainwindow->show();
removeoldwidgets();
previouswidget = 2;
}
}

void Shell::setarchimedes()
{
if (previouswidget != 3)
{
if (previouswidget == 0) startpage->hide();
if (previouswidget == 1) amainwindow->hide();
if (previouswidget == 2) bmainwindow->hide();
if (previouswidget == 4) dmainwindow->hide();
cmainwindow = new Mainwindowc(this,"cmainwindow_eindwerk");
cmainwindow->setMinimumWidth(860);
cmainwindow->setMinimumHeight(600);
cmainwindow->setMaximumWidth(1280);
cmainwindow->setMaximumHeight(1024);
cmainwindow->resize(1020,600); //945,675
this->setCentralWidget(cmainwindow);
cmainwindow->show();
removeoldwidgets();
previouswidget = 3;
}
}

void Shell::setextremaprobs()
{
if (previouswidget != 4)
{
if (previouswidget == 0) startpage->hide();
if (previouswidget == 1) amainwindow->hide();
if (previouswidget == 2) bmainwindow->hide();
if (previouswidget == 3) cmainwindow->hide();

dmainwindow = new Mainwindowd(this,"dmainwindow_eindwerk");
dmainwindow->setMinimumWidth(860);
dmainwindow->setMinimumHeight(600);
dmainwindow->setMaximumWidth(1280);
dmainwindow->setMaximumHeight(1024);
dmainwindow->resize(1020,600); //945,675
this->setCentralWidget(dmainwindow);
dmainwindow->show();
removeoldwidgets();
previouswidget = 4;
}
}

void Shell::removeoldwidgets()
{
if (previouswidget==0) {delete startpage;}
if (previouswidget==1) {delete amainwindow;}
if (previouswidget==2) {delete bmainwindow;}
if (previouswidget==3) {delete cmainwindow;}
if (previouswidget==4) {delete dmainwindow;}
}

void Shell::setstartpage()
{
removeoldwidgets();
previouswidget = 0;
startpage = new StartPage(this,"startpage_eindwerk");
startpage->setMinimumWidth(860);
startpage->setMinimumHeight(600);
startpage->setMaximumWidth(1280);
startpage->setMaximumHeight(1024);
startpage->resize(1020,600);
this->setCentralWidget(startpage);
startpage->show();
}

static const char *description =
  I18N_NOOP("eduKator");
// INSERT A DESCRIPTION FOR YOUR APPLICATION HERE
  
  
static KCmdLineOptions options[] =
{
  {"verbose",I18N_NOOP("Print the results to the stdout."),0},
  { 0, 0, 0 }
  // INSERT YOUR COMMANDLINE OPTIONS HERE
};

int main( int argc, char **argv )
{
//int VERSION = 4;
//QString description = "jaja";
//QString options = "jaja";
const char *VERSION = "versie";
KAboutData aboutData( "edukator", I18N_NOOP("eduKator"),   VERSION, description, KAboutData::License_GPL_V2,  "Muylkens Toon", 0, 0,"toon.muylkens@pandora.be");
aboutData.addAuthor("Muylkens Toon", 0 , "toon.muylkens@pandora.be");
KCmdLineArgs::init( argc, argv, &aboutData );
  KCmdLineArgs::addCmdLineOptions( options ); // Add our own options.


    KApplication::setColorSpec( QApplication::CustomColor );
    KApplication a( argc, argv );
    
QString locale_small;
locale_small=QTextCodec::locale();
locale_small.setLength(2);
//locale_small= "es";

cout <<"EduKator can use : 'nl', 'en', 'fr', 'ru', 'es', 'gl'"<<endl;
cout <<"EduKator will use your language, and otherwise 'en'"<<endl;
cout <<"Your language is: "<<locale_small<<endl;
//locale_small="gr";
    
    QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
 QString translation;
 translation.append(appBaseDir);
 translation.append("translations/translation_");
 translation.append(locale_small);


 translation.append(".qm" );


 /**AANZETTEN VOOR VERTALIN*/
QTranslator myapp( 0 ); 

/**AANZETTEN VOOR VERTALIN*/
myapp.load( QString( translation) );
/**AANZETTEN VOOR VERTALIN*/
 a.installTranslator( &myapp );

//myapp.load( QString( "/usr/share/apps/eindwerk/translations/translation_" ) + QTextCodec::locale(), ".qm" );
    Shell shell(NULL,"shell_eindwerk", NULL);
    shell.setMinimumWidth(860);
    shell.setMinimumHeight(600);
    shell.setMaximumWidth(1280);
    shell.setMaximumHeight(1024);


    //shell.resize(945,665);
    shell.resize(1020,600); //600
 // shell.resize(335,235);
   shell.showMaximized();
    
    shell.updateGeometry();
    
    
    //shell.setCentralWidget(amainwindow);
    
    a.setMainWidget( &shell );  
    
//     if ( QApplication::desktop()->width() > 1200
//          && QApplication::desktop()->height() > 900 )
//     shell.show();
//     else
//        shell.showMaximized();
    
    return a.exec();
    
}

