/***************************************************************************
 *   Copyright (C) 2005 by Toon Muylkens                                   *
 *   toon.muylkens@pandora.be                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "theory.h"

Theory::Theory(QWidget *parent, const char *name, QString pathplace)
 : QWidget(parent, name)
{
 	this->setFont(QFont("Bitstream Vera Sans" , 12, QFont::Normal));
	makegrid();
	addlayouts();
	maketekstinfo(pathplace);
	allesingrid();	  
}


Theory::~Theory()
{
}

void Theory::makegrid()
{
	grid = new QGridLayout( this, 2, 2, 10, -1, "grid");
	theorie = new QVBoxLayout;
	info = new QVBoxLayout;
}

void Theory::addlayouts()
{
	grid->addLayout( theorie, 0, 1 );
	grid->addLayout( info, 0, 0 );
	grid->setColStretch( 1, 10 );
}

void Theory::maketekstinfo(QString pathplace)
{
tekstinfoleft = new QTextBrowser(this, "tekstinfoleft");
tekstinfoleft->setFixedWidth(170);
tekstinfoleft->setText(tr("Welcome,\n\nIn the frame next to this one the theory is explained. Once you know the theory you can make some exercies. You can find these in the 4th tab."));
tekstinforight = new QTextBrowser(this, "tekstinforight");

//nl_BE = nl_NL and en_US = en_VS => limited to 2 digits
QString locale_small;
locale_small=QTextCodec::locale();
locale_small.setLength(2);
//locale_small ="gr";
//end
// not nl ru fr en => en
int a = 0;
if (locale_small == "ru") a =1;
if (locale_small == "nl") a =1;
if (locale_small == "fr") a =1;
if (locale_small == "gl") a =1;
/** Jos, uncomment the following line to use spanish translations*/
//if (locale_small == "es") a =1;
if (locale_small == "en") a =1;
if (a != 1) locale_small="en";
//end
//FOR RUSSIAN TRANSLATION: 
if (locale_small == "ru")
{
tempsource = new  QMimeSourceFactory ();
tempsource->setExtensionType("html", "text/html;charset=iso8859-5");
tekstinforight->setMimeSourceFactory(tempsource);
}
pathplace.append(locale_small);
pathplace.append(".html");
QString appBaseDir = KGlobal::dirs()->findResourceDir("data","edukator/pictures/taba.png")+"edukator/";
QString home;
home.append(appBaseDir);
home.append("html_pages/theory");
home.append(pathplace);
tekstinforight->setSource( home);
//cout <<home<<endl;



}

void Theory::allesingrid()
{
	theorie->addWidget( tekstinforight );
	info->addWidget( tekstinfoleft);
}
 
